<?php

namespace HCM\FPA\ObrigacaoLegal\Dirf\Registros;

use HCM\FPA\ObrigacaoLegal\Dirf\Registros\RegistroDIRF;

class RegistroDECPJ extends RegistroDIRF{

    private $_cnpj;
    private $_nmEmpresarial;
    private $_idNaturezaDecl;
    private $_cpfResponsavel;
    private $_idSocioOstensi;
    private $_idDepositJudic;
    private $_idInstitInvest;
    private $_idPagRendiExte;
    private $_idPagPlanoSaud;
    private $_idPagEntidades;
    private $_idFundaDirPriv;
    private $_idPagSituaEspe;
    private $_dtEventoEspeci;

    private function _geraRegistro($tpRegistro){
        // Ordem 1
        $this->atribuiDadoDirf($tpRegistro);

        // Ordem 2
        $this->atribuiDadoDirf($this->_cnpj);

        // Ordem 3
        $this->atribuiDadoDirf($this->_nmEmpresarial);

        // Ordem 4
        $this->atribuiDadoDirf($this->_idNaturezaDecl);

        // Ordem 5
        $this->atribuiDadoDirf($this->_cpfResponsavel);

        // Ordem 6
        $this->atribuiDadoDirf($this->_idSocioOstensi);

        // Ordem 7
        $this->atribuiDadoDirf($this->_idDepositJudic);

        // Ordem 8
        $this->atribuiDadoDirf($this->_idInstitInvest);

        // Ordem 9
        $this->atribuiDadoDirf($this->_idPagRendiExte);

        // Ordem 10
        $this->atribuiDadoDirf($this->_idPagPlanoSaud);

        // Ordem 11
        $this->atribuiDadoDirf($this->_idPagEntidades);

        // Ordem 12
        $this->atribuiDadoDirf($this->_idFundaDirPriv);

        // Ordem 13
        $this->atribuiDadoDirf($this->_idPagSituaEspe);

        // Ordem 14
        $this->atribuiDadoDirf($this->_dtEventoEspeci);
    }

    public function geraRegistroDECPJ(){
        $this->_geraRegistro(parent::REGISTRO_DECPJ);
    }

    public function setCnpj($cnpj){
        $this->_cnpj = $cnpj;
    }
    public function setNmEmpresarial($nmEmpresarial){
        $this->_nmEmpresarial = $nmEmpresarial;
    }
    public function setIdNaturezaDecl($idNaturezaDecl){
        $this->_idNaturezaDecl = $idNaturezaDecl;
    }
    public function setCpfResponsavel($cpfResponsavel){
        $this->_cpfResponsavel = $cpfResponsavel;
    }
    public function setIdSocioOstensi($idSocioOstensi){
        $this->_idSocioOstensi = $idSocioOstensi;
    }
    public function setIdDepositJudic($idDepositJudic){
        $this->_idDepositJudic = $idDepositJudic;
    }
    public function setIdInstitInvest($idInstitInvest){
        $this->_idInstitInvest = $idInstitInvest;
    }
    public function setIdPagRendiExte($idPagRendiExte){
        $this->_idPagRendiExte = $idPagRendiExte;
    }
    public function setIdPagPlanoSaud($idPagPlanoSaud){
        $this->_idPagPlanoSaud = $idPagPlanoSaud;
    }
    public function setIdPagEntidades($idPagEntidades){
        $this->_idPagEntidades = $idPagEntidades;
    }
    public function setIdFundaDirPriv($idFundaDirPriv){
        $this->_idFundaDirPriv = $idFundaDirPriv;
    }
    public function setIdPagSituaEspe($idPagSituaEspe){
        $this->_idPagSituaEspe = $idPagSituaEspe;
    }
    public function setDtEventoEspeci($dtEventoEspeci){
        $this->_dtEventoEspeci = $dtEventoEspeci;
    }

}