-- ============================================================
-- Database name: FOLHA
-- Created on: 29/04/2019
-- ============================================================
-- ============================================================
--   TABLE: ESO_INFCOMPLEMENTAR
-- ============================================================
create table ESO_INFCOMPLEMENTAR
(
    NRORG NUMBER not null,
    NRINFCOMPLEMENTAR NUMBER not null,
    CDERRO VARCHAR2(10) not null,
    DSERRO,DTINCLUSAO VARCHAR2(4000) not null,
    DSINFCOMPLEMENTAR VARCHAR2(4000) null,
    IDATIVO VARCHAR2(1) default 'S' not null,
    DTINCLUSAO DATE not null,
    DTULTATU DATE null ,
    NRORGINCLUSAO NUMBER(22) default 1 null ,
    CDOPERINCLUSAO VARCHAR2(12) default '1' null ,
    NRORGULTATU NUMBER(22) default 1 null ,
    CDOPERULTATU VARCHAR2(12) default '1' null ,
    constraint ESO_INFCOMPLEMENTAR_PK primary key (NRORG, NRINFCOMPLEMENTAR)
)
/

INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0001','Campo de preenchimento obrigatório: {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0002','O campo não pode ser preenchido: {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0003','Falha ao obter ou disponibilizar as informações na fila de eventos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0005','A data de admissão do trabalhador: Para a categoria [103] (aprendiz), deve ser maior ou igual a [20/12/2000].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0006','A data deverá ser maior que a data de nascimento do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0007','Indicativo de obra não é aceito para empregador pessoa física. \nAção Sugerida: O valor informado no campo deve ser igual a [1 ou 2] se o tipo de inscrição for igual a [2].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0008','Grupo "{0}" deve ser preenchido. Verifique as condições de preenchimento no leiaute.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0011','Falha no acesso a lista de certificados revogados.\nAção Sugerida: Tente mais tarde.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0014','O campo {0} é obrigatório e não foi informado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0015','Foi informado um valor com tipo inválido para o campo {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0016','Foi informado um valor com tamanho inválido para o campo {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0017','A estrutura do arquivo XML está em desconformidade com o esquema XSD.{0}',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0018','Erro processando a solicitação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0019','Falha no processamento da solicitação. Tente novamente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0028','Falha ao atualizar as informações na base de dados do Ambiente Nacional do e- Social.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0031','Falha na disponibilização do resultado do processamento na fila de saída.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0039','Falha ao marcar folhas de pagamento para revalidação,',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0041','Falha ao assinar o recibo de entrega do Evento. Envie o evento novamente, para obter o recibo de entrega.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0051','Número de inscrição foi baixado ou não foi encontrado no Sistema CNPJ. Compareça à unidade local da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0066','Existem trabalhadores com vínculos ativos no e-Social para o período deste evento. Evento de exclusão não permitido.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0069','Não foi possível estabelecer conexão com o Sistema do CNPJ. A falha pode ser temporária, tente novamente mais tarde.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0070','Não foi possível validar a Procuração Eletrônica RFB no sistema administrador da outorga. A falha pode ser temporária, tente novamente mais tarde.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0072','Não foi possível estabelecer conexão com o Sistema do CPF. A falha pode ser temporária, tente novamente mais tarde.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0073','Não foi possível estabelecer conexão com o Sistema do SPED Tabelas. A falha pode ser temporária, tente novamente mais tarde.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0087','Ocorreu uma falha no processamento do arquivo de atualizações gerado pelo Sistema {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0090','Não foi possível validar a Procuração Eletrônica Caixa no sistema administrador da outorga. A falha pode ser temporária, tente novamente mais tarde.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0092','Falha ao obter informações do Sistema de CNO da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0093','Falha ao obter informações do Sistema de CAEPF da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0101','O tipo de evento informado não é aceito para este tipo de lote/serviço.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0102','O Evento informado não foi reconhecido pelo sistema.\nAção Sugerida: Verificar se o evento informado e a versão do leiaute estão de acordo com a Tabela 9 (Tipos de Arquivo do eSocial) do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0103','O Evento informado já se encontra na base de dados do eSocial.\nAção Sugerida:Verificar se já foi informado um evento com a mesma chave de Identificação [Id].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0105','O evento a ser excluído/retificado (alterado) não foi localizado na base de dados do eSocial.\nAção Sugerida:Verificar se o número do recibo informado no evento, corresponde ao mesmo número de recibo do evento original. Preencher com o número do recibo do arquivo a ser retificado',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0106','Foi localizado no sistema um evento em duplicidade com o evento a ser enviado, mesmo {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0108','Ocorreu uma falha durante o envio dos débitos apurados para a DCTF Web. Refaça a solicitação e caso o problema persista entre em contato com o fale conosco do sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0109','Ocorreu uma falha durante a apuração dos débitos tributários da folha de pagamento. Refaça a solicitação e caso o problema persista entre em contato com o fale conosco do sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0113','Falha ao realizar a verificação da versão das tabelas do sistema na base de dados do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0114','Falha ao atualizar as tabelas do sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0120','A folha de pagamento não apresenta erros de validação ou não foi localizado o resultado do processo de revalidação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0121','Já existe na base da dados do eSocial um evento informado com mesma chave de identificação.\nAção Sugerida: Verificar se já foi informado um evento com a mesma chave de Identificação [Id].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0123','Ocorreu uma falha no acesso ao Sistema BDContrib.\nAção Sugerida: Aguarde alguns minutos e tente novamente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0130','É necessário existir informação cadastral do empregador para o período.\nAção Sugerida:Verificar se já foi enviado um evento de cadastramento do empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0131','Existem folhas de pagamento inconsistentes em andamento na base de dados do eSocial: {0}.\nAção Sugerida: Efetuar retificação para compatibilização das inconsistências da folha com os eventos a ela relacionados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0132','O item não poderá ser excluído, pois está sendo utilizado por outro evento já enviado.\nAção Sugerida: Verificar se o evento a ser excluído possui vinculação com outros eventos enviados anteriormente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0133','O item não poderá ser excluído, pois já foram enviados eventos Trabalhistas ou de Folha de Pagamento no período.\nAção Sugerida: Verificar se o evento a ser excluído possui vinculação com outros eventos enviados anteriormente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0136','Não foi possível validar as informações solicitadas, pois os dados não foram localizados no Ambiente Nacional do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0137','Ocorreu uma falha na comunicação com o sistema responsável pela distribuição automática dos eventos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0138','Ocorreu uma falha na geração dos pacotes de eventos durante o envio automático.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0139','Ocorreu uma falha ao marcar os eventos como entregues durante o envio automático.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0140','Ocorreu uma falha ao marcar os eventos como recebidos durante o envio automático.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0142','Assinatura do evento inválida. {0}',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0143','As informações prestadas para o trabalhador de CPF: {0}, do período de apuração {1} tornaram-se inconsistentes devido a uma alteração ocorrida após o envio do evento.\nAção Sugerida: Será necessário retificar a informação prestada.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0144','A alteração do conteúdo de tabela ocorrida após a prestação de informações da folha de pagamento causaram inconsistência nas informações prestadas.\nAção Sugerida: Será necessário retificar a informação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0145','As informações da folha de pagamento sofreram alterações após a apuração dos débitos tributários. \nAção Sugerida: Será necessário solicitar uma revalidação da folha.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0146','Ocorreu uma falha durante a alteração da situação da folha de pagamento em processo de revalidação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0147','Ocorreu uma falha durante a revalidação das informações da folha de pagamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0148','Erro na cadeia do certificado digital do signatário ou do solicitante da informação.\nAção Sugerida:Verificar se a raiz do certificado pertence à Autoridade Certificadora Raiz Brasileira (ICP-Brasil).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0149','A raiz do certificado digital do signatário ou do solicitante da informação deverá pertencer a Autoridade Certificadora Raiz Brasileira (ICP-Brasil).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0150','O certificado digital do signatário ou do solicitante da informação encontra-se revogado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0151','O certificado digital do signatário ou do solicitante da informação encontra-se expirado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0153','O campo com OID {0} do certificado digital não contém a informação obrigatória {1} ou ela não está no formato esperado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0154','A assinatura dos arquivos da eSocial deverá ser realizada com um certificado digital do tipo e-CNPJ ou e-PJ cujo CNPJ base seja o mesmo do contribuinte responsável pela informação, ou no caso de ter sido utilizado um certificado de pessoa física, esse deverá pertencer ao representante legal do contribuinte ou a um procurador devidamente habilitado no sistema de Procuração Eletrônica da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0155','A solicitação de informações ao Ambiente Nacional da eSocial somente poderá ser feita com a utilização de certificado digital do tipo e-CNPJ ou e-PJ cujo CNPJ base seja o mesmo do empregador/contribuinte responsável pela informação, ou no caso de ser utilizado um certificado de pessoa física, esse deverá pertencer ao representante legal do empregador/contribuinte ou a um procurador devidamente habilitado no sistema de Procuração Eletrônica da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0157','Evento de Exclusão ou Retificação deverá ser do mesmo tipo e se referir ao mesmo objeto do evento a ser excluído/retificado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0162','O Trabalhador com Matrícula : {0} consta na base de dados do Ambiente Nacional do eSocial, mas não foi informada sua remuneração. \nAção Sugerida: Verificar se a falta de informação é decorrente de dificuldades operacionais ou se é possível efetuar a regularização.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0163','O Trabalhador sem vínculo com Nome : {0}, CPF : {1}, NIS : {2} e Categoria : {3} consta na base de dados do Ambiente Nacional do eSocial, mas não foi informada sua remuneração.\nAção Sugerida: Verificar a situação do trabalhador e efetuar a regularização.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0170','O Vinculo Trabalhista já se encontra cadastrado na base de dados do Ambiente Nacional do eSocial.\nAção Sugerida: Verificar a matrícula informada e, se já utilizada na admissão de outro empregado, gerar uma nova matrícula.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0171','O Segurado Empregado já foi desligado por motivo de óbito.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0172','Não foi localizado um evento de desligamento por sucessão para o vínculo anterior do Segurado Empregado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0173','Existe no banco de dados do Ambiente Nacional do eSocial um evento anterior a data de admissão informada para o Vínculo Trabalhista.\nAção Sugerida: Verificar o histórico do trabalhador e excluir/retificar os eventos relativos ao empregado existentes no RET.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0174','O evento somente será aceito após a data de início da obrigatoriedade do empregador ao eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0175','O Nome do Trabalhador está diferente do valor encontrado no Sistema da RFB. Valor no Sistema = {0}. \nAção Sugerida: Procure unidade conveniada da RFB e efetue a regularização.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0176','A data de nascimento do Trabalhador está diferente do valor encontrado no Sistema da RFB. \nAção Sugerida: Procure unidade conveniada da RFB e efetue a regularização.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0177','O envio do evento ocorreu em data posterior ao período previsto na legislação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0178','O cadastro inicial do vínculo somente pode ser utilizado para informar os empregados cuja admissão ocorreu antes da obrigatoriedade do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0179','O Segurado Empregado não foi localizado.\nAção Sugerida: Utilize o evento de admissão para cadastramento do vínculo trabalhista do Segurado Empregado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0180','O Vinculo Trabalhista não foi localizado.\nAção Sugerida: Utilize o evento de admissão para cadastramento do vínculo trabalhista.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0181','O Vinculo Trabalhista já se encontra encerrado na data do evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0182','Não foi localizado nenhum Vínculo Trabalhista. O Segurado Empregado se encontra desligado na data do evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0183','Trabalhador afastado não poderá receber este tipo de evento.É necessário que o trabalhador esteja, na data do afastamento, em atividade.\nAções Sugeridas:\n- Verificar se 10 o trabalhador encontra-se ativo para a data constante no evento.\n- Verificar se a data do afastamento está correta.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0187','Para afastamento do trabalhador por motivo de Acidente de Trabalho será necessária a emissão de um Evento de CAT com data anterior ao afastamento.\nAções Sugeridas:\n- Enviar evento CAT - Comunicado de Acidente de Trabalho;\n- Verificar se o motivo do afastamento está correto.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0188','Para que haja um Retorno do Afastamento é necessário que o trabalhador esteja afastado.\nAções Sugeridas:\n- Verificar se o afastamento foi cadastrado.\n- Verificar a data de retorno do afastamento. A data de retorno do afastamento deve ser, sempre, maior ou igual ao afastamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0191','Não é permitido o desligamento do trabalhador.\nAções Sugeridas:\n- Verificar se o trabalhador encontra-se ativo\n- Verificar se o motivo do desligamento do trabalhador é compatível com o desligamento sem retorno do afastamento',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0193','Vínculo Trabalhista já se encontra reintegrado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0194','A comunicação do aviso prévio não poderá ter data futura em relação a data atual.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0196','A data de admissão do trabalhador deverá ser maior que o último evento trabalhista enviado para o trabalhador no vínculo da empresa sucedida.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0197','A data de admissão do trabalhador não poderá ser anterior à data de abertura da empresa ou posterior a sua data de encerramento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0199','O código do motivo anterior informado no evento deve ser igual ao código de motivo do afastamento indicado no evento de afastamento a ser alterado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0200','Evento de início de condições ambientais do trabalho não localizado ou condições ambientais já possuem evento de término. \nAção Sugerida:\nPara aceitação do evento de alteração ou de término de \"Condições Ambientais do Trabalho\" é necessária:\n- a existência de evento de INÍCIO para o mesmo vínculo, código de ambiente, descrição de atividade em data anterior a data do evento \n- que não conste o evento de TÉRMINO para a Condição Ambiental do Trabalho.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0212','O Segurado Empregado já recebeu uma CAT por motivo de óbito.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0213','Para admissão de trabalhador por transferência, sucessão, incorporação ou fusão a data de início do vínculo informada no registro de Sucessão de Vínculo Trabalhista deverá corresponder a data de admissão do trabalhador no primeiro vínculo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0214','O Código do Motivo do afastamento no evento para término do Afastamento, deverá ser o mesmo do Afastamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0216','O Vínculo Trabalhista Já se encontra sob aviso prévio no período\nAção Sugerida: Não pode haver outro evento de AVISO PRÉVIO para o mesmo vínculo, salvo se houver o respectivo evento de CANCELAMENTO DE AVISO PRÉVIO com data anterior a data do novo evento de AVISO PRÉVIO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0217','Não foi localizado para o Vinculo Trabalhista um evento de Aviso Prévio no período.\nAção Sugerida: Para aceitação do evento é necessária a existência de evento de AVISO PRÉVIO para o mesmo vínculo em data anterior à data do evento, e para o qual ainda não conste evento de CANCELAMENTO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0218','Vínculo Trabalhista não se encontra desligado.\nAção Sugerida: Para recepção do evento de Reintegração é necessária a existência de evento de desligamento para o mesmo vínculo e com data do desligamento anterior à data da reintegração. Se o trabalhador foi \"desligado\" da empresa antes do início do eSocial, é necessária a existência do evento de admissão com o preenchimento do campo data de desligamento, o qual dispensa a necessidade da existência do evento específico de desligamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0221','Desligamento não poderá ser excluído após a admissão do trabalhador na empresa sucessora.\nAção Sugerida: A exclusão de evento será rejeitada em caso de desligamento cujo motivo seja igual a [11,12, 13] conforme Tabela 19 (Motivos de Desligamento), e já exista evento de admissão por sucessão para o mesmo trabalhador na empresa sucessora, indicada no campo CNPJ da empresa Sucessora.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0222','A solicitação de informações ao Ambiente Nacional da e-Social somente poderá ser feita com a utilização de certificado digital do tipo e-CNPJ ou e-Pj de Órgão previamente cadastrado para tanto.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0223','O CPF informado não foi localizado no Cadastro da RFB ou está em situação irregular.\nAções Sugeridas:\n- Verifique se o CPF informado está correto;\n- Efetuar a regularização do CPF.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0225','Não foi localizado o evento de admissão do trabalhador na empresa cedente.\nAções Sugeridas:\n- A informação da origem do trabalhador cedido deverá ter a data de início igual ou superior a data de início de vigência do eSocial (deve existir o vínculo do trabalhador na empresa cedente).\n- . Verificar se os seguintes campos estão preenchidos corretamente:\n- CPF do trabalhador;\n- CNPJ da empresa cedente;\n- Matrícula do trabalhador no empregador de origem (Cedente,SYSDATE);\n- Data de admissão do trabalhador na empregador de origem (Cedente).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0226','O trabalhador não se encontra afastado na empresa cedente por motivo de cessão, ou a data de admissão não é imediatamente posterior à data de afastamento do 12 cedente.\nAção Sugerida:\nDeve existir afastamento pelo motivo de \"Cessão\" no empregador Cedente em data imediatamente anterior a data de início na empresa cessionária',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0227','Caso deseje alterar o NIS será necessário alterar as informações cadastrais do trabalhador. \nAções Sugeridas:\n- Verifique se o NIS está correto;\n- Caso deseje alterar o NIS será necessário alterar as informações cadastrais do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0232','Versão do leiaute do evento trabalhista não é reconhecida pelo sistema ou foi substituída.\nAção Sugerida: Utilize a última versão disponível, para o tipo de evento trabalhista, no sítio do eSocial',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0233','O cadastro do empregador encontra-se inconsistente em relação ao Sistema da RFB.\nAção Sugerida: Verifique as informações prestadas ao eSocial ou regularize as informações junto à RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0234','O cadastro de estabelecimentos e obras encontra-se inconsistente em relação ao Sistema da RFB.\nInconsistência(s) identificada(s):\n {0}\nAção Sugerida: Verifique as informações prestadas ao eSocial ou regularize as informações junto à RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0235','Grau de exposição a agentes nocivos inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela de Grau de Exposição a Agentes Nocivos conforme Tabela 2 (Tabela de Grau de Exposição a Agentes Nocivos).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0237','Categoria do trabalhador incompatível com a classificação tributária do empregador.\nAção Sugerida: A categoria informada no campo deverá ser compatível com a classificação tributária do CONTRIBUINTE informada no Evento de “Informações Cadastrais do Empregador” campo classificação tributária, conforme Tabela 11 (Compatibilidade entre Categoria de Trabalhadores, Classificação Tributária e Tipos de Lotação).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0238','A categoria informada deve ser relativa a Segurado Empregado.\nAção Sugerida: Para aceitação do evento devem ser observadas as seguintes regras de compatibilidade entre a categoria de trabalhador e o evento utilizado: O evento S-2200 (Admissão de Trabalhador) só será aceito para as categorias de trabalhadores igual a [101, 102, 103, 104, 105, 106, 111, 301, 302, 303, 306, 307, 309]. O evento S-2300 (Trabalhador Sem vínculo - Início) somente é aceito para as categorias de trabalhadores igual a [201, 202, 305, 308, 401, 410, 701, 711, 712, 721, 722, 723, 731, 734, 738, 741, 751, 761, 771, 781, 901, 902, 903, 904, 905].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0239','Motivo do afastamento inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 18 (Motivo do Afastamento)',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0240','Código do país inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 6 (Países).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0241','Motivo do desligamento inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 19 (Motivo do Desligamento).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0242','Natureza Jurídica inválida.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 21 (Natureza Jurídica).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0243','CNAE inválido.\nAção Sugerida: Preencher com o código do CNAE conforme tabela do Anexo V do Regulamento da Previdência Social, referente à atividade econômica preponderante do estabelecimento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0244','Natureza da rubrica inválida.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 3 (Natureza das Rubricas da Folha de Pagamento).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0245','FPAS inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 4 (Códigos e Alíquotas de FPAS/Terceiros).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0246','CID inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela de CID (Classificação Internacional de Doenças).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0247','Código de Terceiros incompatível com o FPAS informado.\nAção Sugerida: O valor informado no campo deverá ser compatível com o código FPAS que consta na Tabela 4 (Códigos e Alíquotas de FPAS/Terceiros).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0248','Código do município inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela de Municípios do IBGE',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0249','Unidade da Federação inválida.\nAção Sugerida: O valor informado no campo deverá existir na Tabela de Unidade da Federação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0250','Tipo de inscrição inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 5 (Tipos de Inscrição).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0252','CBO inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela de CBO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0253','Categoria do trabalhador inválida.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 1 (Categorias de Trabalhadores).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0254','Tipo de serviço inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela de Classificação de Serviços Prestados por Cooperativa.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0255','Classificação tributária inválida.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 8 (Classificação Tributária).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0256','Indicativo de suspensão da exigibilidade.\nAção Sugerida: O valor informado no campo deverá existir na Tabela de Tipo de Decisão Judicial/Administrativa.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0258','Situação geradora do acidente inválida.\nAção Sugerida: A situação geradora do acidente deve existir na Tabela 16 (Situação Geradora do Acidente de Trabalho).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0259','Informação da parte do corpo atingida inválida.\nAção Sugerida: Preencher com o código correspondente a parte do corpo atingida, conforme Tabela 13 (Parte do Corpo Atingida).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0260','Agente causador inválido.\nAção Sugerida: O valor informado deve ser um código válido, existente em uma das tabelas 14 (Agente Causador do Acidente de Trabalho) ou 15 (Agente Causador / Situação Geradora de Doença Profissional).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0261','Categoria do trabalhador incompatível com a lotação e classificação tributária do empregador.\nAção Sugerida: O valor informado no campo deverá ser compatível com a Lotação e classificação tributária do CONTRIBUINTE informada no Evento de \"Informações Cadastrais do Empregador\", conforme Tabela 11 (Compatibilidade entre Categoria de Trabalhadores, Classificação Tributária e Tipos de Lotação)',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0262','Lotação não existe no cadastro do empregador.\nAção Sugerida: O valor informado no campo Código de Lotação deverá existir na Tabela de Lotações Tributárias, informada pelo empregador. ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0263','Cargo não existe no cadastro do empregador.\nAção Sugerida: O valor informado no campo de Código do Cargo deverá existir na Tabela Tabela de Cargos/Empregos Públicos, informada pelo empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0264','Função não existe no cadastro do empregador.\nAção Sugerida: O valor informado no campo Código da Função deverá existir na Tabela de Funções/Cargos em Comissão, informada pelo empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0265','Rubrica incompatível com Segurado Empregado.\nAção Sugerida: Se for relativa a segurado empregado ou avulso não é permitida a inclusão de RUBRICAS com Código de incidência de Contribuição Previdenciária igual a [34] – SEST.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0266','Rubrica incompatível com Contribuinte Individual.\nAção Sugerida:\nSe for relativa a contribuinte individual, não podem ser utilizadas rubricas cuja classificação de incidência tributária informada nos campos, códigos de incidência tributária de Contribuição Previdenciária e códigos de incidência tributária de IRRF, seja específica de segurados empregados. Portanto, não são aceitas rubricas cujo:\n- Código de Incidência 15 tributária de Contribuição Previdênciária igual a: [12, 21, 22, 32, 51,92, 93, 94], exceto se categoria de trabalhador = [771];\n- Código de Incidência tributária de IRRF igual a: [12,13,14,32,33,34];\n- Código de Incidência tributária de Contribuição Previdenciária seja igual a [34] se a CATEGORIA do respectivo trabalhador for diferente de [711,712,734];\n- Código de Incidência tributária de Contribuição Previdenciária classificado como [31] se a classificação tributária do contribuinte for igual a [21,22] (Pessoa Física) e Categoria = Contribuinte individual (7XX), pois não existe previsão legal de desconto de contribuição do segurado contribuinte individual que é contratado por outro contribuinte individual, exceto se o tipo de Lotação da respectiva lotação = [22] (obra de pessoa física).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0267','Rubrica incompatível com Estagiário.\nAção Sugerida: Se for relativa ao estagiário, não podem ser aceitas rubricas cujo Código de Incidência tributária de Contribuição Previdênciária ou Código de Incidência tributária de FGTS seja diferente de [00].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0268','Rubrica incompatível com Dirigente Sindical.\nAção Sugerida: \" (essa não é uma mensagem) Mostrar a mensagem de acordo com a classificação da "categoria de origem": se empregado ou contribuinte individual \"',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0269','Rubrica não existe no cadastro do empregador.\nAções Sugeridas:\n- Verifique se a rubrica está cadastrada na tabela de rubricas; \n- Verifique o preenchimento das informações referentes à rubrica informada.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0270','Processo não existe no cadastro do empregador.\nAções Sugeridas:\n- Verifique se o processo está cadastrado na tabela de processos;\n- Verifique o preenchimento das informações referentes ao processo informado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0271','Os Horários/Turnos de Trabalho não existem no cadastro do empregador. \nAções Sugeridas:\n- Verifique se os Horários/Turnos de Trabalho estão cadastrados na tabela de Horários/Turnos de Trabalho;\n- Verifique o preenchimento das informações referentes aos Horários/Turnos de Trabalho informados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0272','A inscrição informada deve ser o CPF do empregador, caso de empregador doméstico, ou ser um estabelecimento do empregador devidamente cadastrado no sistema no período.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0273','Operador Portuário não existe no cadastro do empregador.\nAções Sugeridas:\n- Verifique se o Operador Portuário está cadastrado na tabela de Operadores Portuários;\n- Verifique o preenchimento das informações referentes ao Operador Portuário informado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0274','O valor informado deve coincidir com o somatório do campo Valor do repasse dos recursos repassados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0275','O valor informado deve corresponder à soma do valor bruto das notas fiscais.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0276','O valor informado deve corresponder à soma do valor da Contribuição Previdenciária descontada pelo adquirente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0277','O valor informado deve corresponder à soma do valor da GILRAT.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0278','O valor informado deve corresponder à soma do valor da contribuição destinada ao SENAR.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0279','O valor informado deve corresponder a 2% do valor bruto ou ZERO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0280','O valor informado deve corresponder a 0,1% do valor bruto ou ZERO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0281','O valor informado deve corresponder a 0,2% do valor bruto ou ZERO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0282','Número do processo judicial inválido.\nAção Sugerida: Verifique se as informações do número do processo e tipo do processo estão corretas.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0283','Número do processo administrativo inválido.\nAção Sugerida: Verifique se as informações do número do processo e tipo do processo estão corretas.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0284','O indicativo de suspensão utilizado é incompatível com o tipo do processo.\nAção Sugerida: Verifique o campo indicativo de suspensão:\nSe Tipo de Processo = 1 - (Administrativo), o indicativo de suspensão deve ser igual a [03, 14, 92]. Se Tipo de Processo = 2 - (Judicial), o indicativo de suspensão deve ser igual a [01, 02, 04, 05, 08, 09, 10, 11, 12, 13, 90, 92]. Se Tipo de Processo = 4 - (Processo FAP), o indicativo de suspensão deve ser igual a [14].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0285','O valor informado deverá ser maior que ZERO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0286','A data informada deverá ser maior ou igual à data de abertura da empresa.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0287','A data de fim de validade deverá ser maior ou igual à data de início de validade.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0289','O Percentual de Redução da Contribuição deverá ser ZERO para Contribuição Patronal integralmente Substituída.\nAção Sugerida: O campo deverá ser preenchido com ZERO se o Indicativo de substituição da contribuição previdenciária patronal ou Indicativo de substituição da contribuição previdenciária patronal Operador Portuário for igual a [Sim] ou [1] - (Integralmente Substituída).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0290','A quantidade de dependentes para fins de salário-família informada deve ser igual ou inferior a quantidade de dependentes existente no cadastro do trabalhador.\nAção Sugerida: Verificar o número de dependentes informados no cadastro do trabalhador para fins de salário-família.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0291','A quantidade de dependentes para fins de dedução do IRRF informada deve ser igual ou inferior a quantidade de dependentes existente no cadastro do trabalhador.\nAção Sugerida: Verificar o número de dependentes informados no cadastro do trabalhador para fins de para fins de dedução do IRRF.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0292','A data de validade do documento deverá ser posterior à data da expedição.\nAção Sugerida: A data de validade informada deve ser igual ou posterior a data de expedição do documento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0294','O preenchimento do campo CPF dos dependentes é obrigatório.\nAção Sugerida:\nVerifique a idade e dependência de IRRF do dependente. O CPF do dependente torna-se obrigatório para idade maior ou igual a 12 (doze) anos e que seja dependente de IRRF nos eventos de cadastro (S-2200, S-2205 e S-2300). Nos demais eventos, o campo é obrigatório para maior ou igual a 12 anos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0295','Foi identificado um vinculo trabalhista anterior para o trabalhador.\nAção Sugerida:\nIndicar se trata-se do primeiro emprego do trabalhador:\nS – Sim; N – Não. Se Indicativo de Primeiro Emprego igual a Sim, não poderá existir Evento de Admissão ou Cadastramento Inicial de Vinculo com data do evento anterior para o mesmo trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0297','A data deverá ser menor ou igual a data do Atestado de Saúde Ocupacional emitido.\nAção Sugerida: Informar data de exame menor ou igual a data informada no campo Data do ASO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0298','A data de desligamento deverá ser maior ou igual a data do Aviso Prévio.\nAção Sugerida: Informar data de desligamento maior ou igual a data do Aviso Prévio.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0299','Se o tipo do CAT for igual a 3 o campo deverá indicar que houve óbito.\nAção Sugerida: Se o Tipo de CAT for igual a [3] - Comunicação de Óbito, o campo comunicação de óbito, deverá sempre ser preenchido com \"S\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0302','A data deverá ser igual ou anterior à data do efetivo retorno ao trabalho.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0303','Não foi localizado o contrato de trabalho do trabalhador CPF: {0} e Categoria: {1}.\nAção Sugerida: Utilize o evento S-2300 - Trabalhador Sem Vínculo de Emprego/Estatutário – Início, para cadastramento do contrato de trabalho conforme tabela 1 (Categorias de Trabalhadores).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0304','Não existe um Contrato de Trabalho para o CPF: {0} ou este encontra-se encerrado na data do evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0308','Para este tipo de lotação o campo deverá ser preenchido com o número de inscrição de um estabelecimento do empregador.\nAção Sugerida: Deve ser um código 18 válido, existente na Tabela 10 (Tipos de Lotação Tributária) e compatível com a Classificação Tributária indicada no evento de Informações Cadastrais do Empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0309','O campo deve ser preenchido apenas no caso de remuneração de trabalhador EMPREGADO (conforme tabela de categorias).\nAção Sugerida: Verifique se a categoria é mesmo de empregado, só neste caso a matrícula deve ser informada.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0310','A rubrica não poderá ser utilizada por trabalhador afastado.\nAção Sugerida: Verifique as compatibilidades das rubricas/categorias utilizadas nos eventos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0311','A rubrica não é compatível com o tipo de regime previdenciário.\nAção Sugerida: Verifique as compatibilidades das rubricas com o Regime Previdenciário do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0312','A categoria informada deve ser igual a existente no cadastro do trabalhador no Ambiente Nacional da eSocial.\nAção Sugerida: Verificar a categoria informada conforme Tabela 1, (Categorias de Trabalhadores).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0314','Deve ser informado pelo menos um registro de remuneração vinculado ao estabelecimento/lotação existente no cadastro do Trabalhador no Ambiente Nacional do eSocial.\nAção Sugerida: A informação de estabelecimento do trabalhador empregado é prestada no evento de admissão, podendo ser modificada pelo evento de alteração do contrato de trabalho, devendo ser observada, ainda, a informação vigente para o período de apuração ao qual se refere a remuneração.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0315','Deverá existir um Evento de Desligamento para o Trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0317','O trabalhador deverá encontrar-se ativo no período.\nAção Sugerida: Verificar se o trabalhador relacionado encontra-se ativo no período.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0318','O trabalhador sem vínculo deverá encontrar-se ativo no período.\nAção Sugerida: Verificar se o trabalhador relacionado encontra-se ativo no período.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0319','Os valores monetários indicados no registro de remuneração devem ser iguais aos valores informados no evento de desligamento.\nAção Sugerida: Se o registro Informação da Rescisão for preenchido, os valores monetários indicados em Remuneração do Trabalhador no Período de Apuração, devem ser iguais aos valores informados no evento de desligamento indicado pelo número de Recibo de Desligamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0320','O Evento de Desligamento relativo ao Vinculo Trabalhista {0}, com Número de Recibo {1} não foi informado.\nAção Sugerida: Se existir no RET evento de desligamento para o trabalhador/vínculo ao qual se refere a remuneração, deve ser preenchida a informação relativa ao número do evento de desligamento, no registro Informação da Rescisão.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0321','O valor total da aquisição deve corresponder a soma do valor bruto das notas fiscais.\nAção Sugerida: Deve corresponder a soma de Valor Bruto dos registros vinculados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0322','O tipo de inscrição não é compatível com o indicativo da aquisição.\nAção Sugerida:\nSe tipo de inscrição é igual a 2 (CPF), o Indicativo da Aquisição informado deve ser igual a [1] ou [2]. Se tipo de inscrição é igual a 1 (CNPJ), o Indicativo da Aquisição informado deve ser igual a [3].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0324','Evento exclusivo de Cooperativa de Trabalho.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0329','O valor informado no campo deve ser igual ou inferior ao valor dos Serviços Sujeitos a retenção/contribuição adicional (15 anos).\nAção Sugerida: O valor informado no campo Deve ser igual ou inferior ao Valor dos Serviços sujeitos a retenção/contribuição adicional (15 anos).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0330','O valor informado no campo deve ser igual ou inferior ao valor dos Serviços Sujeitos a retenção/contribuição adicional (20 anos).\nAção Sugerida: O valor informado no campo Deve ser igual ou inferior ao Valor dos Serviços sujeitos a retenção/contribuição adicional (20 anos).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0331','O valor informado no campo deve ser igual ou inferior ao valor dos Serviços Sujeitos a retenção/contribuição adicional (25 anos).\nAção Sugerida: O valor informado no campo Deve ser igual ou inferior ao Valor dos Servicos sujeitos a retenção/contribuição adicional (25 anos).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0332','O valor informado no campo deve corresponder a soma das Bases de cálculo da contribuição.\nAção Sugerida: O valor informado no campo Deve corresponder a soma das Bases de cálculo da contribuição.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0333','O valor informado no campo deve ser maior ou igual a soma das Bases de cálculo da contribuição.\nAção Sugerida: O valor informado no campo Deve corresponder a soma das Bases de cálculo da contribuição.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0334','O valor informado no campo deve corresponder a soma do Valor dos Materiais/Equipamentos e Valor dos Serviços.\nAção Sugerida: O valor informado no campo deverá corresponder a soma dos campos Valor dos Materias/Equipamentos e Valor dos Serviços.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0335','O evento é incompatível com a classificação tributária do empregador.\nAção Sugerida:\nVerificar compatibilidade entre o tipo de evento e a classificação tributária do contribuinte, conforme abaixo: (Conforme Tabela 8 - Classificação Tributária)\na) O evento S-1250 (Aquis. Prod Rural) não deve ser informado pela classificação Tributária [22];\nb) O evento S-1260 (Comerc. Prod Rural) somente pode ser informado pelas 20 classificaçãoTributária [21,22];\nc) O evento S-1280 – Informações Complementares aos Eventos Periódicos somente pode ser enviado por empregador cuja classificação tributária seja igual a [02,03,09, 99].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0339','O tipo de incidência [2] (Atividade Concomitante) somente pode ser utilizado por contribuinte cuja classificação tributária seja igual a [03]. Para contribuintes com a classificação tributária igual a [01, 04, 22, 70, 80] o tipo de incidência deve ser igual a [9].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0340','Deve corresponder ao somatório do campo "vlrBaseCoop" dos registros "n130", exceto no caso de empresa enquadrada na classificação tributária igual a [03], onde o valor deve corresponder ao somatório de "vlrBaseCoop" dos registros "n130" menos o "vlrBaseCoop" dos registros "n132". Em ambos os casos, considerar apenas os registros vinculados ao mesmo estabelecimento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0341','Deve corresponder ao somatório do campo "vlrServicos15" dos registros "n131", exceto no caso de empresa enquadrada na classificação tributária igual a [03], onde o valor deve corresponder ao somatório de "vlrServicos15" dos registros "n130" menos o "vlrBaseCoop15" dos registros "n132". Em ambos os casos, considerar apenas os registros vinculados ao mesmo estabelecimento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0342','Deve corresponder ao somatório do campo "vlrServicos20" dos registros "n131", exceto no caso de empresa enquadrada na classificação tributária igual a [03], onde o valor deve corresponder ao somatório de "vlrServicos20" dos registros "n130" menos o "vlrBaseCoop20" dos registros "n132". Em ambos os casos, considerar apenas os registros vinculados ao mesmo estabelecimento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0343','Deve corresponder ao somatório do campo "vlrServicos25" dos registros "n131", exceto no caso de empresa enquadrada na classificação tributária igual a [03], onde o valor deve corresponder ao somatório de "vlrServicos25" dos registros "n130" menos o "vlrBaseCoop25" dos registros "n132". Em ambos os casos, considerar apenas os registros vinculados ao mesmo estabelecimento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0344','Em arquivo gerado por PJ, são permitidos os códigos [1,8,9]. Em arquivo gerado por PF, são permitidos os códigos [2,3,8,9].\nAção Sugerida: Se o campo Tipo de Inscrição for igual a 1 – (CNPJ) são permitidos os códigos [1,8,9]. senão (PF), são permitidos os códigos [2,3,8,9].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0345','O valor no campo deverá ser igual a soma do Valor Bruto da Comercialização.\nAção Sugerida: Se Indicativo de Comercialização for igual a [3], deve corresponder a soma do campo Valor bruto da comercialização da produção dos registros vinculados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0346','Tipo de inscrição do adquirente incompatível com o indicativo de comercialização.\nAção Sugerida: Se o indicativo de comercialização for igual a [3], deve ser igual a [1,2]. Se o indicativo de comercialização for igual a [8], deve ser igual a [1].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0347','O valor informado no campo não pode ser superior ao Valor Bruto da Comercialização.\nAção Sugerida: Preencher com zero se não houver informação a ser prestada. O valor informado não pode ser superior ao Valor bruto da comercialização da produção.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0348','O valor retido de Produtor Rural, deve ser preenchido apenas para adquirente pessoa física.\nAção Sugerida: Deve ser preenchido apenas se o Tipo de Inscrição for igual a [2] - (CPF).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0349','O CNAE informado deverá estar cadastrado para o estabelecimento no cadastro do Sistema CNPJ da RFB.\nAção Sugerida: O CNAE informado deverá estar cadastrado para o CNPJ de referência no cadastro do Sistema CNPJ.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0353','Caso a data de admissão seja posterior a 04/10/1988, a data de opção deve ser igual à data de admissão.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0354','A data deverá ser menor que a data de admissão do trabalhador.\nAção Sugerida: A data informada no campo deverá ser menor que a Data de Admissão.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0355','A data de opção pelo FGTS deverá ser compatível com a categoria do trabalhador.\nAção Sugerida:\nPara categoria do trabalhador (campo Código da Categoria) igual à:\n1 - 104 (doméstico) Se a data de admissão é igual ou posterior a 01/10/2015, a data de opção deve ser igual à data de admissão; Se a data de admissão é entre 01/03/2000 e 30/09/2015, a data de opção deve ser entre a data de admissão e 01/10/2015; Se a data de admissão é anterior a 01/03/2000, a data de opção deve ser entre 01/03/2000 e 01/10/2015.\n2 - 721 (Diretor não empregado com FGTS), a data de opção deve ser igual ou posterior à data de admissão e nunca anterior a 02/06/1981.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0356','O Tipo do Trabalhador é incompatível com a classificação tributária do empregador.\nAção Sugerida:\nVerificar se o tipo de trabalhador é compatível com a classificação tributária do contribuinte (informada no evento de informações do empregador):\n1) O tipo \"Avulso\" somente poder ser utilizado se a classificação tributária for igual a [09] ou [10];\n2) O tipo \"Cooperado\" somente pode ser utilizado se o Indicativo de Cooperativa definido no evento de informações cadastrais do empregador for diferente de \"zero\";\n3) O tipo \"Dirigente Sindical\" somente pode ser utilizado se a classificação tributária for igual a [10] ou [14];\n4) O tipo \"Diretor não empregado\" e \"Servidor Público indicado...\" somente podem ser utilizados se o tipo de Inscrição do 22 empregador for igual a [1] - (PJ).\n5) O tipo \"Estagiário\" não pode ser utilizado pela classificação tributária [22] (Segurado Especial).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0358','Não foi localizado um Evento de CAT com o número de recibo de entrega informado.\nAção Sugerida:O número informado deve ser de uma CAT já informada anteriormente, pertencente ao mesmo trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0359','A categoria de origem não poderá ser Dirigente Sindical.\nAção Sugerida: O código da categoria informado não poderá pertencer ao grupo \"Dirigente Sindical\" conforme Tabela 1( Categorias de Trabalhadores).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0362','A receita bruta total deverá ser maior ou igual a receita no mês.\nAção Sugerida: O valor informado no campo deverá maior ou igual ao valor informado no campo Receita Bruta Total no Mês.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0363','A receita bruta de atividade sem substituição acumulada deverá ser maior ou igual a receita bruta de atividade sem substituição no mês.\nAção Sugerida: O valor informado no campo deverá maior ou igual ao valor informado no campo Receita Bruta de Atividade sem substituição no Mês.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0364','O valor deverá corresponder ao resultado da divisão entre a receita bruta de atividade sem substituição no mês e receita no mês.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0365','O valor deverá corresponder ao resultado da divisão entre a receita bruta de atividade sem substituição acumulada e receita bruta total.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0366','Para trabalhador admitido a partir de 04/10/1988, o campo deve ser preenchido como \"Optante\".\nAção Sugerida: Preencher o campo de opção pelo FGTS como \"1\" - \"optante\" ou alterar a data de admissão, caso esteja incorreta.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0367','Total de Salário Família informado diverge do calculado pelo sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0368','Total de Salário Maternidade informado diverge do calculado pelo sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0369','A data não poderá ser maior que hoje.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0370','A data deverá ser maior ou igual à data de admissão do trabalhador//Data de início do contrato de trabalho.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0371','A alíquota deverá ser compatível com o CNAE preponderante informado.\nAção Sugerida: Verifique se a alíquota e o CNAE estão corretos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0373','O valor informado para o FAP difere do valor que consta do Cadastro da RFB para o Empregador/Estabelecimento. {0}.\nAção Sugerida: O FAP informado deve corresponder aquele definido para a empresa no cadastro da RFB. Só será permitida divergência se houver preenchimento do registro de informações do processo judicial - alíquota FAP. Na primeira vez que o empregador/contribuinte enviar este evento e, caso possua processo judicial ou administrativo relacionado ao FAP, deve enviá-lo já com os dados dos processos judiciais/administrativos, bem como os seus efeitos na definição do valor do campo FAP. Neste caso, antes do envio de qualquer evento periódico é necessário o envio das informações do respectivo processo através do evento S-1070 (Tabela de processos).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0374','O FAP deverá ser preenchido com valores entre 0,5000 e 2,0000, inclusive.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0376','A Alíquota após ajuste pelo FAP deverá ser igual a Alíquota RAT x FAP.\nAção Sugerida: O campo Aliquota do RAT após ajuste pelo FAP deve corresponder ao resultado da multiplicação dos campos Aliquota RAT e FAP.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0377','O número de processo informado não foi localizado no cadastro do empregador.\nAção Sugerida: Verifique se o processo administrativo ou judicial está correto e se já foi cadastrado no sistema - Tabela de Processos (S-1070)',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0378','O número de processo judicial informado não foi localizado no cadastro do empregador no período.\nAção Sugerida: Verifique se o processo foi cadastrado e se é um processo judicial ou corrija o campo de tipo de processo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0379','Indicativo de Cooperativa incorreto.\nAção Sugerida: Somente pode ser diferente de ZERO se natureza jurídica for igual a [2143] e classificação Tributária for igual a [06, 07, 13, 99], sendo que para classificação Tributária for igual a [06,07] o campo deverá ser preenchido apenas com [0,2].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0380','CNPJ inválido.\nAção Sugerida: Confira os valores informados no campo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0381','CPF inválido.\nAção Sugerida: Confira os valores informados no campo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0382','CAEPF inválido.\nAção Sugerida: Confira os valores informados no campo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0383','Classificação tributária incompatível.\nAção Sugerida:\nEmpregador Pessoa Física deverá utilizar as classificações tributárias 21 e 22.\nEmpregador Pessoa Jurídica deverá utilizar uma das demais classificações tributárias existentes na Tabela 8 (Classificação Tributária).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0384','Tipo de Inscrição incompatível.\nAção Sugerida: O campo deve preenchido com [2,3,4] (CPF. CAEPF, CNO) se a classificação tributária do Empregador for igual a [21,22], ou [1,4] (CNPJ, CNO) nos demais casos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0385','Preencher o campo com mês/ano para folha de pagamento mensal e apenas com ano para folha de pagamento de décimo terceiro salário.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0386','Para evento de retificação ou exclusão é necessário informar o número do recibo do evento a ser retificado/excluído. Caso contrário, não pode preencher o número do recibo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0387','Classificação tributária exclusiva para base de alcântara.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0388','Tipo de lotação incompatível.\nAção Sugerida: Tipo de Lotação deverá ser compatível com a classificação tributária do empregador cadastrada para o período da lotação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0389','Tipo de inscrição incompatível com o tipo de lotação\nAção Sugerida: O campo deverá ser preenchido com um Tipo de Inscrição compatível com o Tipo de Lotação, conforme definido na \"Tabela 10 - (Tipo de Lotação)\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0391','CNO inválido.\nAção Sugerida: Confira os valores informados no campo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0393','Número de Inscrição do Segurado (NIS) inválido.\nAção Sugerida: Confira os valores informados no campo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0394','Hora inválida.\nAção Sugerida: Confira os valores informados no campo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0396','O Valor somente poderá ser igual a ZERO quando a contribuição sobre o limite máximo de salário de contribuição já foi descontada/recolhida em outra(s) empresa(s).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0397','O campo deverá ser preenchido com valor diferente do CNPJ do declarante do evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0398','Deve ser informado um valor diferente do CNPJ/CPF do empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0402','Percentual inválido.\nAção Sugerida: O valor informado no campo deverá ser igual a [ recBrutaExp12m / ( Receita Bruta Total 12m - vlrTribRecBruta ) ] x 0,1 x 100',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0403','Data inválida.\nAção Sugerida: A data de vencimento do certificado deverá ser maior ou igual a data de emissão do certificado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0404','O CNPJ base informado deverá ser diferente do CNPJ base do informante do evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0406','O CPF informado no campo deverá ser igual ao CPF do Empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0407','O CNPJ informado deve possuir raiz igual ao cnpj que consta no registro de abertura.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0408','CAEPF inconsistente.\nAção Sugerida: O CAEPF deverá estar ativo no Cadastro de CAEPF da RFB e deverá estar vinculado ou pertencer ao informante do Evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0409','CNO inconsistente.\nAção Sugerida: O CNO informado deverá pertencer ao CNPJ/CPF vinculado, ou a um dos seus estabelecimentos cadastrados no Evento de \"Estabelecimentos e Obras\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0410','CNO inconsistente.\nAção Sugerida:O CNO deverá ser um CNO ativo no Cadastro de Obras da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0411','CNPJ inconsistente.\nAção Sugerida: O CNPJ deverá ser um CNPJ ativo no Cadastro de Estabelecimentos e Obras do Ambiente Nacional do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0412','CNPJ inconsistente.\nAção Sugerida: O CNPJ deve estar ativo no Cadastro de CNPJ da RFB e estar vinculado ao empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0413','CNO inconsistente.\nAção Sugerida: Se Indicativo de Obra for igual a 1 - (Empreitada Total), o número do CNO informado deve ser de propriedade de Identificação do estabelecimento ou obra Prestadora.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0414','CNO inconsistente.\nAção Sugerida: O CNO informado deve pertencer ao contratante do serviço.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0416','O tipo de inscrição CAEPF somente poderá ser utilizado por empregador pessoa física.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0417','Valor incorreto.\nAção Sugerida: O valor deverá corresponder à soma das rubricas que compõem a base de cálculo da contribuição previdenciária relativas à proventos menos as relativas à descontos.\nVerifique os cálculos',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0418','Valor incorreto.\nAção Sugerida: O valor deverá corresponder à soma das rubricas que compõem a base de cálculo de IRRF relativas à proventos menos as relativas à descontos.\nVerifique os cálculos',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0419','Valor incorreto.\nAção Sugerida: O valor deverá corresponder à soma das rubricas que compõem a base de cálculo de FGTS relativas à proventos menos as relativas à descontos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0420','Valor incorreto.\nAção Sugerida: O valor deverá corresponder à soma das rubricas que compõem os descontos relativos a contribuição previdenciária destinada a seguridade social.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0421','Valor incorreto.\nAção Sugerida: O valor deverá corresponder à soma das rubricas relativas à vencimentos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0422','Valor incorreto.\nAção Sugerida: O valor deverá corresponder à soma das rubricas relativas à descontos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0423','Valor incorreto.\nAção Sugerida: O valor deverá ser igual a vencimentos menos descontos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0424','Rubrica não permitida em folha de décimo terceiro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0425','Existe remuneração informada para o Estabelecimento {0} na folha de pagamento, no entanto não consta base de cálculo ou contribuição.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0426','Não foi localizada remuneração para o Estabelecimento {0} na folha de pagamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0427','Existe remuneração informada para a Categoria {0} e Incidência {1}, no entanto a informação não consta da base de cálculo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0428','Não foi localizada remuneração para a Categoria {0} e Incidência {1}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0429','Total da base de cálculo difere do calculado pelo sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0430','Total descontado do segurado difere do calculado pelo sistema.\nAção Sugerida:\nO valor informado no campo deverá ser igual ao somatório dos Registros dos Eventos de Remuneração, agrupando por Categoria do Trabalhador, Tipo de Incidência, Tipo de Inscrição e Número de Inscrição do Estabelecimento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0431','Total da Base de Cálculo da Contribuição Adicional (15 anos) difere do calculado pelo sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0432','Total da Base de Cálculo da Contribuição Adicional (20 anos) difere do calculado pelo sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0433','Total da Base de Cálculo da Contribuição Adicional (25 anos) difere do calculado pelo sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0434','O CNPJ do Operador Portuário {0} deverá ser informado.\nAção Sugerida: Deve ser um CNPJ válido, diferente do CNPJ base indicado em S-1000 e dos estabelecimentos informados através do evento S-1005.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0435','O Estabelecimento {0} não poderá ser informado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0436','Total da Base de Cálculo da Gilrat difere do calculado pelo sistema.\nAção Sugerida: Deve corresponder a soma do campo Base de Cálculos da Contribuição Previdenciária dos registros de Remuneração no Periodo Apuracao relativos aos trabalhadores avulsos vinculados ao estabelecimento indicado na "Identificação do Estabelecimento" = "Identificação do Estabelecimento de Lotação", e que cuja lotação seja no Operador Portuário indicado no registro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0437','O par FPAS e Código de Terceiros {0} deverá ser informado.\nAção Sugerida: Informar o FPAS e o código de terceiros correspondente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0438','O par FPAS/Código de Terceiros {0} não deverá ser informado.\nAção Sugerida: Não informar FPAS e Código de Terceiros.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0439','Total da Base de Cálculo da Gilrat difere do calculado pelo sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0440','O tipo de Contribuição {0} deverá ser informado.\nAção Sugerida: Informar tipo de contribuição.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0441','O Tipo de Contribuição {0} não deverá ser informado.\nAção Sugerida: Não informar o tipo de contribuição.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0442','Valor da contribuição não corresponde ao calculado pelo sistema.\nAção Sugerida: O valor da contribuição informado no campo, deverá corresponder ao valor da contribuição apurado pelo sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0443','O par FPAS/Código de Terceiros {0} deverá ser informado.\nAção Sugerida: Informar o FPAS e o código de terceiros correspondente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0444','O para FPAS/Código de Terceiros {0} não deverá ser informado.\nAção Sugerida: Não informar FPAS e Código de Terceiros.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0445','O código de terceiros deverá ser igual a soma dos códigos de terceiro vinculado, excluindo as repetições.\nAção Sugerida: O campo deve corresponder à soma dos códigos individuais de cada Código de Terceiro desconsiderando os códigos que se repetirem.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0446','O valor total da contribuição de terceiros deve corresponder a soma da contribuição de cada terceiro.\nAção Sugerida: O campo deve corresponder a soma do campo Valor de Terceiro dos Registros.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0447','O par Código de Terceiro/ Alíquota {0} deverá ser informado.\nAção Sugerida: Informar o Código de Terceiro/Aliquota correspondente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0448','O par Código de Terceiro/ Alíquota {0} não deverá ser informado.\nAção Sugerida: Não informar o Código de Terceiro/Aliquota.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0449','Valor da contribuição do terceiro diferente do calculado pelo sistema.\nAção Sugerida: O valor da contribuição de terceiro informado no campo, deverá corresponder ao valor da contribuição apurado pelo sistema.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0458','A informação prestada no campo deverá ser igual a prestada na abertura da folha de pagamento.\nAção Sugerida: Para recepção do evento é necessário que já tenha sido enviado o evento de \"abertura\" da folha de pagamentos (original ou com indicativo de retificação) para o período de apuração indicado no evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0459','Não foi localizado um evento para o recibo de entrega informado ou o mesmo foi excluído/retificado.\nAção Sugerida: Deverá existir um Evento já recebido, \"Ativo\" (não excluído ou retificado), com número de recibo de entrega igual ao informado no campo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0460','A data deverá estar contida no período de apuração.\nAção Sugerida: O mês/ano da emissão da nota fiscal deve ser igual ao mês/ano indicado no registro de abertura do arquivo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0461','Período inválido.\nAção Sugerida: Informar o período ao qual se refere o complemento de remuneração, no formato MM/AAAA (Aplicação Web) ou AAAA-MM (Webservices), no caso de pagamento de folha mensal, ou AAAA, no caso específico do 13º salário.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0462','Período inválido.\nAção Sugerida: A data, mês/ano ou ano, informado para o campo deverá ser anterior ao período de apuração ao qual se refere o arquivo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0463','Data inválida.\nAção Sugerida: A data deve estar compreendida no período de apuração ao qual se refere o arquivo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0464','O valor informado não confere com a soma do valor bruto das notas fiscais de serviços.\nAção Sugerida: O valor informado deve corresponder à soma do campo Valor Bruto dos registros vinculados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0465','O valor informado não confere com a soma do valor dos serviços das notas fiscais.\nAção Sugerida: O valor informado deve corresponder à soma do campo Valor dos Serviços dos registros vinculados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0466','O valor informado não confere com a Soma do valor da retenção das notas fiscais de serviço.\nAção Sugerida: O valor informado deve corresponder à soma do campo Valor da Retenção dos registros vinculados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0467','O valor informado não confere com a soma da bases de cálculo da retenção.\nAção Sugerida: O valor informado deve corresponder à soma do campo \"Valor da Base de Cálculos de Retenção\" dos registros vinculados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0468','O valor informado não confere com a soma do valor do adicional de retenção das notas fiscais.\nAção Sugerida: O valor informado deve corresponder à soma do campo Valor Adicional dos registros vinculados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0469','O valor informado deve ser igual ao valor da retenção calculada menos valor já retido em relação aos serviços subempreitados.\nAção Sugerida: O valor informado deve corresponder ao Valor de Retenção Apurada menos o Valor de Retenção dos Serviços Subempreitados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0471','O valor informado neste campo deve corresponder ao somatório de 4% sobre o Serviços sujeitos a retenção/contribuição adicional (15 anos) mais 3% sobre Serviços sujeitos a retenção/contribuição adicional (20 anos) mais 2% sobre Serviços sujeitos a retenção/contribuição adicional (25 anos).\nAção Sugerida: Se existir informação em Serviços Prestados Condições Especiais correspondente, o valor informado neste campo deve corresponder ao somatório de 4% sobre o \"Valor dos Serviços sujeitos a retenção/contribuição adicional 15 anos\" mais 3% sobre \"Valor dos Serviços sujeitos a retenção/contribuição adicional 20 anos\" mais 2% sobre \"Valor dos Serviços sujeitos a retenção/contribuição adicional 25 anos\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0472','O valor informado não confere com a soma do valor da retenção não efetuada.\nAção Sugerida: O valor informado deve corresponder à soma de Valor não Retido dos registros vinculados as notas fiscais emitidas para o contratante.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0473','O valor informado no campo deverá ser maior ou igual ao somatório dos Valor dos Serviços sujeitos a retenção/contribuição adicional (15/20 e 25 anos).\nAção Sugerida: O somatório dos campos \"Valor dos Serviços sujeitos a retenção/contribuição adicional 15 anos\", \"Valor dos Serviços sujeitos a retenção/contribuição adicional 20 anos\" e \"Valor dos Serviços sujeitos a retenção/contribuição adicional 25 anos\", não pode ser superior ao Valor Base de Retenção indicado na nota fiscal correspondente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0474','O valor informado no campo deverá ser maior que o somatório entre Valor da Retenção e Valor do Adicional de Retenção.\nAção Sugerida: O valor informado não pode ser maior que o somatório de Valor de Retenção e Valor Adicional.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0475','O valor informado deverá ser menor ou igual ao valor bruto.\nAção Sugerida: O valor informado não pode ser superior ao Valor Bruto.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0476','O valor informado deverá ser menor ou igual ao valor do serviço.\nAção Sugerida: O valor informado não pode ser superior ao Valor dos Serviços.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0477','Valor inválido.\nAção Sugerida: O valor informado deve corresponder ao Valor dos Serviços menos o Valor das Deduções.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0478','O valor informado deverá ser menor ou igual a Retenção Apurada.\nAção Sugerida: O valor informado não pode ser superior ao Valor de Retenção Apurada.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0480','Ocorreu uma falha ao atualizar as informações cadastrais obtidas do arquivo gerado pelo Sistema CNIS.\nAção Sugerida: Tente novamente mais tarde. Caso o problema continue, consulte o suporte.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0481','O valor informado não pertence aos valores válidos para o campo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0483','Logradouro inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 20 (Tipos de Logradouros).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0484','Preencher com CNPJ quando Indicador de Múltiplos Vínculos igual a 3.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0485','O número de inscrição não poderá pertencer ao próprio trabalhador.\nAção Sugerida: Se o Tipo de Inscrição for igual a [2], deve ser um CPF válido e diferente do CPF do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0488','O CNPJ/CPF informado não consta como proprietário da Obra no Cadastro Nacional de Obras.\nAção Sugerida: Se o tipo de lotação indicar empreitada parcial [02], o CNO informado no campo Numero da Inscrição deve pertencer ao CNPJ/CPF indicado no campo Número de Inscrição do Proprietário.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0491','A soma da Base de Cálculo do FGTS e respectivas verbas indenizatórias deverá corresponder à soma das rubricas que compõem a base de cálculo de FGTS relativas a proventos menos as relativas a descontos.\nAção Sugerida: Deve corresponder ao somatório do campo Valor Total da Rubrica, das rubricas cujo Tipo seja igual a [1,3] menos as rubricas cujo Tipo seja igual a [2,4], relacionadas nos registros de itens da remuneração (vinculados a este) e cuja classificação da rubrica no campo \"Código de 31 incidência da rubrica para o FGTS\" da tabela de RUBRICAS para o respectivo código tenha sido definido como [11].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0492','Este evento não pode ser excluído.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0493','Data inválida.\nAção Sugerida: A data prevista para o término do estágio deverá ser maior que a data de início do estágio.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0494','O número do processo judicial é obrigatório quando o tipo de reintegração for Decisão Judicial.\nAção Sugerida: Preencha a informação com o número do processo judicial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0495','O campo número da Lei de Anistia é obrigatório quando o tipo de reintegração for Anistia Legal.\nAção Sugerida: O campo número da Lei de Anistia é obrigatório quando o campo Tipo de Reintegração for = [2] - Reintegração por Anistia Legal. Caso contrário o campo não deverá ser preenchido.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0496','O campo somente deve ser preenchido se a categoria corresponder a \"Diretor Não Empregado\" [721,722].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0498','O Prestador de Serviço ({0}), indicativo de obra ({1}) e CNO ({2}) foram informados no evento de Serviços Tomados, no entanto não foram totalizados no evento de bases de cálculo e contribuições.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0499','O Prestador de Serviço ({0}), indicativo de obra ({1}) e CNO ({2}) não foram informados no evento de Serviços Tomados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0500','A soma do valor da retenção das notas fiscais de serviço é diferente da calculada pelo sistema.\nAção Sugerida: O valor informado deve corresponder à soma do campo Valor de Retenção dos registros Notas Fiscais de Terceiros (Evento \"Serviços Tomados - Cessão de Mão de Obra ou Empreitada\") relativos ao prestador de serviços, e com Indicativo de Obra e Número do CNO iguais aos indicados no registro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0501','A soma do valor do adicional de retenção das notas fiscais é diferente da calculada pelo sistema.\nAção Sugerida: Deve corresponder a soma do campo Valor Adicional dos registros Notas Fiscais de Terceiros (Evento \"Serviços Tomados - Cessão de Mão de Obra ou Empreitada\") relativos ao prestador de serviços, e com Indicativo de Obra e Número do CNO iguais aos indicados no registro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0502','A soma do Valor da retenção que deixou de ser efetuada pelo contratante das notas fiscais é diferente da calculada pelo sistema.\nAção Sugerida: Deve corresponder a soma do campo Valor não Retido dos registros de Informação de Processo Judicial vinculados às notas fiscais de terceiros informadas no Evento \"Serviços Tomados - Cessão de Mão de 32 Obra ou Empreitada\" e relativos ao prestador de serviços, Indicativo de Obra e Número do CNO indicados no registro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0503','O Proprietário de Obra ({0}) foi informado nas notas fiscais, no entanto não foi localizado no evento de bases de cálculo e contribuições.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0504','O Proprietário de Obra ({0}) não foi informado nas notas fiscais,',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0505','O Contratante do Serviço ({0}), indicativo de obra ({1}) e CNO ({2}) foram informados no evento de Serviços Prestados, no entanto não foram totalizados no evento de bases de cálculo e contribuições.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0506','O Contratante do Serviço ({0}), indicativo de obra ({1}) e CNO ({2}) não foram informados no evento de Serviços Prestados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0507','O Contratante do Serviço ({0}), CNO ({1}) e Categoria do Trabalhador ({2}) foram informados no evento de Remuneração, no entanto não foram totalizados no evento de bases de cálculo e contribuições.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0508','O Contratante do Serviço ({0}), CNO ({1}) e Categoria do Trabalhador ({2}) não foram informados no evento de Serviços Prestados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0509','O Proprietário de Obra ({0}) foi informado nos eventos de remuneração, no entanto não foi localizado no evento de bases de cálculo e contribuições.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0510','O Proprietário de Obra ({0}) não foi informado nos eventos de remuneração.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0511','A soma da base de cálculo da contribuição previdenciária para o trabalhador difere da calculada pelo sistema.\nAção Sugerida: Deve corresponder ao somatório de Base de cálculo da contribuição previdenciária dos registros Remuneração Período de Apuração cujo Código da Categoria seja igual ao Código da Categoria deste registro e cuja lotação do trabalhador seja o contrante/obra também indicados no registro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0512','Número do CEP inválido.\nAção Sugerida: Verifique se o número está preenchido corretamente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0513','O Período de Referência ({0}), Matrícula ({1}) e Categoria do Trabalhador ({2}) não foram Totalizados.\nAção Sugerida: Apresenta a totalização das remunerações do trabalhador, tanto do período de apuração quanto de períodos anteriores (se houver). A totalização das informações é efetuada por período, matrícula e categoria.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0514','Não foi localizada remuneração para o Período de Referência ({0}), Matrícula ({1}) e Categoria do Trabalhador ({2}).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0515','A soma da base de cálculo da contribuição previdenciária para o trabalhador é diferente da calculada pelo sistema.\nAção Sugerida: Deve corresponder a soma de Base de cálculo da contribuição previdenciária de Remuneração Período de Apuração ou de Remuneração de Periodo Anterior para a categoria e matrícula indicados, conforme o caso.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0516','A soma da base de cálculo do FGTS para o trabalhador é diferente da calculada pelo sistema.\nAção Sugerida: Deve corresponder a soma de Base de Cálculo de FGTS de Remuneração de Período de Apuração ou de Remuneração de Periodo Anterior para a categoria e matrícula indicados, conforme o caso.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0518','A soma do valor descontado do segurado é diferente da calculada pelo sistema.\nAção Sugerida: Deve corresponder a soma de Valor total da contribuição descontada dos segurados de Remuneração de Periodo Apuracao ou de Remuneração de Periodo Anterior para a categoria e matrícula indicados, conforme o caso.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0519','A data informada deverá ser maior ou igual a 01/01/1967.\nAção Sugerida: Verificar se a data informada atende a condição de ser maior ou igual a 01/01/1967.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0520','O trabalhador CPF: {0}, não foi cadastrado no sistema.\nAção Sugerida: Efetue o cadastro por meio de um evento de admissão ou cadastramento de trabalhador sem vínculo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0522','O CNO informado deve pertencer ao prestador do serviço.\nAção Sugerida: Caso seja igual a [1] (empreitada total), o Número do CNO deve pertencer ao prestador de serviços indicado em CNPJ Cooperativa.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0523','Para Operador Portuário o FPAS aceito é apenas o 680.\nAção Sugerida: O campo deverá ser preenchido com \"680\", se o campo Tipo de Lotação for igual a \"08 - Operador Portuário\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0528','O CPF informado não foi localizado no Cadastro da RFB ou consta como CANCELADO.\nAção Sugerida: Compareça à unidade local da RFB para regularizar a situação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0531','A natureza jurídica informada é diferente da que consta no Sistema CNPJ da RFB. Regularize a situação.\nAção Sugerida: O preenchimento do campo é obrigatório e exclusivo para empregador PJ. Neste caso, deve ser um código existente na Tabela 21 (Natureza Jurídica) e compatível com a informação constante no CNPJ.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0532','Agente químico inválido.\nAção Sugerida: O código do agente químico a ser informado, deverá existir na Tabela 7 (Resultado da Monitoração Biológica).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0533','O material biológico é incompatível com o agente químico.\nAção Sugerida: O Material Biológico deverá ser compatível com o agente químico, conforme Tabela 7 (Resultado da Monitoração Biológica).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0534','A análise efetuada é incompatível com o agente químico e material biológico.\nAção Sugerida: A Análise Efetuada deverá ser compatível com o Material Biológico e com o agente químico conforme Tabela 7 (Resultado da Monitoração Biológica).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0535','A data deverá ser maior ou igual à data de início da monitoração.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0536','Informações de Empregador, trabalhador e/ou período de apuração incompatíveis.\nAção Sugerida: O Empregador, trabalhador e/ou período de apuração informados no evento de exclusão deverão ser os mesmos que constam do evento a ser excluído.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0537','Já existe no sistema registro com mesmo código de identificação (chave) em período de vigência conflitante com o período informado no registro atual.\nAção Sugerida: O evento somente pode ser recepcionado se não existir outro evento para a tabela com o mesmo código de identificação (chave) em período de vigência conflitante com o período informado no evento atual.\nCertifique-se que o codígo de identificação e os períodos informados estejam corretos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0538','Idade incompatível com a categoria de aprendiz [103].\nAção Sugerida: A idade do trabalhador aprendiz deve ser de 14 a 24 anos e, se deficiente, pode ser maior de 24 anos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0539','Motivo do afastamento anterior não é compatível com o novo motivo informado.\nAção Sugerida:\nA alteração do motivo de afastamento é permitida desde que evento de afastamento tenha ocorrido pelos motivos 01, 03, 06. \nAs alterações permitidas são:\n- de 01 para 03;\n- de 01 para 06;\n- de 03 para 01;\n- de 03 para 06.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0540','Deverá ser informado um email válido.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0541','Nome inválido.\nAção Sugerida:\nO nome informado:\na) Não pode começar com espaço;\nb) Não pode ter mais de um espaço entre palavras;\nc) Não pode conter mais que três letras iguais consecutivas;\nd) A primeira parte do nome deve ter pelo menos dois caracteres;\ne) Não pode ter mais de 2 letras isoladas (abreviações) em sequência.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0543','Já existe na base de dados do Ambiente Nacional um evento com mesmo identificador (Identificador: {0}). Evento: (Recibo: {1}).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0544','Categoria do trabalhador incompatível.\nAção Sugerida:A categoria \"trabalhador cedido\" [410] somente poderá ser utilizada pela administração pública.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0546','A solicitação de informações ao Ambiente Nacional da ESocial somente poderá ser feita com a utilização de certificado digital do tipo e-CNPJ ou e-Pj de Órgão previamente cadastrado para tanto.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0547','A data de nascimento do Trabalhador está diferente do valor encontrado no Sistema CNIS ou o NIS não foi encontrado para o CPF na base CNIS e não é possível validar a data de nascimento do Trabalhador.\nAção Sugerida: Verifique se as informações do evento estão corretas ou providencie a regularização das informações incorretas.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0548','CNAE inválido.\nAção Sugerida:\nO CNAE informado deverá estar cadastrado para o estabelecimento no Cadastro de Atividades Econômicas de Pessoa Física – CAEPF da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0549','CNAE inválido.\nAção Sugerida: O CNAE informado deverá estar cadastrado para o estabelecimento no Cadastro Nacional de Obras – CNO da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0550','Informação somente poderá ser prestada por OGMO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0551','A autoria da ação em processos com Depósito do Montante Integral - Indicativo de Depósito = [S], deverá ser do próprio contribuinte - Indicativo de Autoria = [1].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0552','Quantidade de casas decimais inválida.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0553','Grupo "{0}" não deve ser preenchido. Verifique as condições de preenchimento no leiaute.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0554','Pelo menos um dos campos de telefone deve ser preenchido.\nAção Sugerida: O preenchimento do fone fixo é obrigatório se o fone celular não for preenchido.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0555','ID inválido.\nAção Sugerida: O ID informado no lote deverá ser igual ao informado no respectivo evento A tag evento do lote cujo id é {0} contém na tag conteudo um evento cujo identificador é diferente deste.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0557','O cadastramento do empregador não pode ser excluído.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0558','O Indicativo de Substituição da Contribuição Patronal de Obra de Construção Civil está inválido. \nAção Sugerida: O campo deve ser preenchido a partir da data de início da obra constante no cadastro CNO da seguinte forma: Para obras iniciadas até 31/03/2013, deve ser igual a [2]. Para obras iniciadas entre 01/04/2013 e 31/05/2013, deve ser igual a [1]. Para obras iniciadas entre 01/06/2013 e 31/10/2013, pode ser igual a [1] ou [2]; Para obras iniciadas entre 01/11/2013 e 30/11/2015, deve ser igual [1]; Para obras iniciadas a partir de 01/12/2015 pode ser igual a [1] ou [2].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0559','Indicativo de Desoneração da Folha incompatível.\nAção Sugerida: O campo Indicativo de Desoneração da Folha só pode ser igual a [1] quando a classificação tributária for igual a [02,03,99]. Nos demais casos, deve ser igual a [0].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0560','O valor do campo Indicativo de Substituição da Contribuição Patronal de Obra de Construção Civil deve ser único para o CNO, independente do período. Não pode haver alteração no campo após o primeiro cadastro do CNO no eSocial. Ou seja: Se já existe um evento de Estabelecimentos e Obras Civis para o CNO no eSocial, Tipo de Inscrição e número de Inscrição do grupo Identificação do estabelecimento ou obra já existem, independente do período, para o mesmo CONTRIBUINTE, o valor do campo Indicativo de Substituição da Contribuição Patronal de Obra de Construção Civil deverá ser idêntico ao que se encontra já cadastrado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0562','O telefone deve conter no mínimo dez dígitos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0564','O campo somente pode ser preenchido com números.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0565','O Código de Terceiro é incompatível com o código das Entidades Sociais para as quais a categoria econômica deve contribuir (Código de Terceiros).\nAção Sugerida: Deve ser um código de terceiro válido e compatível com o FPAS/Terceiros informado, conforme tabela de Códigos e Alíquotas de FPAS/Terceiros (Tabela 4).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0566','O evento é incompatível com o tipo de apuração.\nAção Sugerida: O evento não pode ser informado em arquivo relativo ao décimo terceiro salário - Indicativo de período de apuração = [2].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0567','Para esta forma de apuração do FAP deverá ser informado, no cadastro do empregador, o processo FAP relacionado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0568','Já existe na base de dados do sistema um evento com mesma identificação, para esta folha de pagamento.\nAção Sugerida:Caso você deseje substituir o evento de folha deverá excluir o evento anterior. Caso contrário, verifique as informações do evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0569','Valor de retenção incompatível.\nAção Sugerida:O valor de retenção deve corresponder a 5% do valor bruto. Para utilizar um valor diferente, informe um processo judicial/administrativo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0571','Código do Rendimento Inválido.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0573','O tipo de rendimento não poderá ter a exigibilidade suspensa.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0574','Tipo de rendimento incompatível com décimo terceiro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0575','Tipo de isençao incompatível com o tipo de rendimento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0576','O indicativo de período deve ser compatível com o indicativo de décimo terceiro.\nAção Sugerida: O campo deve ser igual a [1] se Indicativo de Décimo Terceiro = [N]. ou igual a [2] se Indicativo de Décimo Terceiro = [S].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0577','Valor de rendimento tributável incompatível.\nAção Sugerida:Valor do rendimento tributável deverá corresponder à soma dos rendimentos informados nos períodos de referência.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0578','Valor da despesa com advogado deverá corresponder à soma das despesas por advogado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0579','Resultado do ASO incompatível com tipo de ASO.\nAção Sugerida: Quando o Tipo do ASO é \"Admissional\", o Resultado do ASO deve ser \"Apto\" ou \"Apto com restrições\". Quando o Tipo do ASO for \"Demissional\", o Resultado do ASO deve ser \"Apto\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0583','O campo é obrigatório quando existir Pagamento do Aviso Prévio Indenizado.\nAção Sugerida: O campo é obrigatório quando existir Pagamento do Aviso Prévio Indenizado = [S], devendo ser igual ou posterior à data de desligamento. Se Pagamento do Aviso Prévio Indenizado igual a [N], o campo é opcional.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0584','A {0} deve ser igual ou posterior à data de desligamento do trabalhador.\nAção Sugerida: A data preenchida no campo {1} deve ser igual ou posterior ao campo Data de Desligamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0585','Não é permitida a exclusão de evento de desligamento se existir evento de Reintegração para o mesmo vínculo com data posterior à data do desligamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0588','Preencha com Sim quando existir remuneração no período e Não quando não existir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0589','Preencha com Sim quando existir informação de pagamento de rendimento do trabalho no período e Não quando não existir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0590','Preencha com Sim quando existir informação de pagamento a beneficiário não identificado no período e Não quando não existir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0593','Preencha com Sim quando existir informação aquisição de produção rural no período e Não quando não existir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0594','Preencha com Sim quando existir informação de comercialização de produção no período e Não quando não existir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0595','Preencha com Sim quando existir informação de contratação de trabalhadores avulsos não portuários no período e Não quando não existir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0596','Preencha com Sim quando existir informações complementares aos eventos periódicos para o período e Não quando não existir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0599','O lote deverá conter somente eventos pertencentes ao mesmo empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0600','Falha ao receber a solicitação de serviço/lote de eventos. Contate o administrador do sistema. Identificação do erro: {0}',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0602','Houve falha no retorno da integração com a Tabela de Órgãos e Municípios - TOM. A falha pode ser temporária, tente novamente mais tarde.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0603','A solicitação encontra-se em processamento.\nAção Sugerida: Aguardar o processamento da solicitação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0604','O retorno do processamento do lote somente é acessível a quem enviou a solicitação.\nAção Sugerida: Verificar se o CNPJ/CPF solicitante do resultado do processamento é o mesmo do transmissor da solicitação de serviço.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0605','Lote inexistente ou enviado a mais de {0} dias.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0606','Foi identificado um erro na estrutura da solicitação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0607','O número de inscrição do transmissor deverá ser igual ao CNPJ/CPF do certificado utilizado para o envio do lote.\nAção Sugerida: Verificar se o número de inscrição do transmissor é igual ao CNPJ/CPF do certificado utilizado para envio do lote.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0608','Versão do lote não é válida. Versões válidas: {0}\nAção Sugerida: A versão do lote deverá ser uma versão válida.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0609','ID Inválida.\n\nAção Sugerida:\n\nDeve ser uma chave válida, conforme abaixo:\n\nTexto fixo \"ID\"\n2 posições\n\n Tipo de Inscrição do Empregador:\n1 posição\n1: CNPJ\n2: CPF\n\nNúmero de inscrição do Empregador:\n14 posições (completar com zeros à direita).\nAno/mês/Dia de geração do evento (AAAAMMDD)\n8 posições\nHora/Minuto/Segundo de geração do evento\n6 posições\n\nSeqüencial da chave. Incrementar somente quando ocorrer geração de eventos na mesma data e segundo\n5 posições ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0611','A quantidade de eventos no lote deve ser entre 1 e {0}.\nAção Sugerida: Ação Sugerida: Montar o lote com no mínimo 1 e no máximo {0} eventos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0612','O tamanho máximo permitido para o lote é {0}.\nAção Sugerida: O tamanho máximo da mensagem não poderá ultrapassar o valor de {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0613','Foi identificado um erro na estrutura da solicitação. \nAção Sugerida: Consulte o manual do usuário do sistema para maiores detalhes.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0614','Para a natureza jurídica e tipo de pagamento o beneficiário não poderá ser o próprio empregador.\nAção Sugerida: Em arquivo gerado por PJ, o Número de Inscrição do Beneficiário somente pode ser igual ao Número de Inscrição que consta na Identificação do Empregador se a natureza jurídica do contribuinte for igual a [212-7]. Se for diferente, pode ser aceito apenas se o código de pagamento for igual a [1708,3426].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0615','O tipo de pagamento não é compatível com o tipo de inscrição do empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0616','Quando se tratar de folha de pagamento normal o mês/ano de apuração deverá ser menor ou igual ao mês/ano corrente. Para folha de pagamento de décimo terceiro o ano de apuração deverá ser menor ou igual ao ano corrente.\nAção Sugerida: Se Indicativo de período de apuração for igual a [1] (mensal), o mês/ano do período de apuração deverá ser igual ou inferior ao mês/ano corrente. Se Indicativo de período de apuração for igual a [2] (décimo terceiro), o ano do período de apuração deverá ser igual ou inferior ao ano corrente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0617','O trabalhador não poderá ter vínculos concomitantes para o mesmo tipo de contrato.\nAção Sugerida: Não é possível o envio de dois eventos de início de trabalhador sem vínculo para o mesmo trabalhador (CPF) e categoria, exceto se já houver respectivo evento de \"término\" anterior ao envio do segundo evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0618','A data {0} deve ser posterior a data de admissão e anterior ao início do eSocial.\nAção Sugerida: O valor informado no campo deverá ser maior que a data de admissão e menor que a data de início de obrigatoriedade do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0619','Verifique os dados informados pois apresentam divergência entre CPF e NIS, ou o NIS não foi localizado na base do CNIS.\nPara orientações, faça a Consulta de Qualificação Cadastral no link http://esocial.dataprev.gov.br/Esocial/pages/index.xhtml',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0620','A folha de pagamento do período {0} já foi fechada, para alterá-la será necessário reabri-la.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0621','Não é permitida a retificação de aviso prévio cancelado.\nAção Sugerida: Não deve ser aceita a retificação de evento de aviso prévio para o qual já exista evento de cancelamento do aviso prévio respectivo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0622','O trabalhador não foi cadastrado no sistema.\nAção Sugerida: Efetue o cadastro por meio de um evento de cadastramento de trabalhador sem vínculo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0623','Sr. Empregador, sua condição de Segurado Especial foi encerrada, pois ocorreu uma mudança nas informações do Cadastro de Atividade Econômica de Pessoa Física (CAEPF). Caso seja necessário, verifique as informações no Sistema CAEPF ou com a unidade responsável da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0624','Deseja excluir o {0}?',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0625','Operação realizada com sucesso.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0626','Nenhum registro identificado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0627','Usuário não tem permissão de acesso ao sistema.\nAção Sugerida: Verifica que ocorreu um erro na obtenção da identificação do Empregador no Sistema de Controle de Acesso.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0628','A data {0} deve ser igual ou posterior à data {1}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0629','O {0} deve ter no mínimo {1} caracteres.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0630','A data {0} é inválida.\nAção Sugerida: Data informada na aplicação Web deverá estar no formato DD/MM/AAAA ou MM/AAAA, no webservices o formato deverá ser AAAA-MM-DD ou AAAA-MM.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0631','O período de validade informado é conflitante (sobrepõe) com os períodos já cadastrados.\nAção Sugerida:\nCorrija a informação de período de validade.\nO período de validade das informações do Empregador (data início e data fim) não pode ser conflitante (sobrepor) com períodos de validade já cadastrados.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0632','Já existe no evento um grupo com mesma chave de identificação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0633','Já existe uma alteração {0} registrada na mesma data. Deseja retificá-la?',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0634','As informações cadastrais foram obtidas automaticamente a partir do cadastro do trabalhador considerando a data de admissão/início informada. Caso necessário, edite as informações.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0635','O valor do campo não poderá iniciar com o texto \"eSocial\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0636','O campo é obrigatório quando o tipo do publico alvo for "Segurado Diferenciado".\nAção Sugerida: Preenchimento obrigatório se tipo de público alvo = [6].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0637','Preenchimento incorreto de campo.\nAção Sugerida: O campo somente pode ser preenchido quando classificação tributária do Empregador for igual a [85] - Ente Federativo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0638','O ambiente informado no evento é incompatível com a url utilizada.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0639','O processo de emissão do evento não é válido.\nAção Sugerida:\nO processo de emissão igual a [1] - Aplicativo do Empregador somente será aceito quando o evento for transmitido utilizando os webservices disponibilizados para o empregador\nO processo de emissão igual a [2] - Aplicativo Governamental - Empregador doméstico somente será aceito quando o evento for gerado e transmitido pela aplicação web do eSocial\nO processo de emissão igual a [3] - Aplicativo Governamental - Web Geral somente será aceito quando o evento for gerado e transmitido pela aplicação web do eSocial para Web Geral',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0640','Antes de incluir um novo horário de trabalho, verifique se já não existe o mesmo cadastrado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0641','O campo é obrigatório quando o tipo do intervalo da jornada for igual a horário fixo.\nAção Sugerida: O campo deve ser preenchido quando Tipo de Intervalo da Jornada = 1 - (Intervalo em Horário Fixo), caso contrário o campo não pode ser informado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0642','Não existem [eventos/documentos] disponíveis para o trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0643','Não há [eventos/documentos] permitidos para o usuário.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0645','Número de Inscrição está anulado ou não foi encontrado no Cadastro CNPJ da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0646','O CNPJ completo somente pode ser utilizado por órgãos públicos, os demais empregadores deverão informar somente o CNPJ base (8 primeiros dígitos do CNPJ).\nAção Sugerida: Se o empregador for um ente da administração direta federal o campo Número de Inscrição "nrInsc" deve ter tamanho de 14 dígitos exatos. Caso contrário, o campo "nrInsc" deve ter tamanho de 8 dígitos exatos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0647','Data incorreta.\nAção Sugerida: A data deve ser uma data posterior a data do aviso prévio que está sendo cancelado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0648','O valor informado deverá corresponder a uma data no formato AAAAMM.\ nAção Sugerida: Preencher com o mês e ano de início da validade das informações prestadas no evento, no formato AAAA-MM.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0649','O CNPJ Matriz do CNPJ Base {0} do declarante não consta no cadastro da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0650','Código de Terceiros incompatível.\nAção Sugerida: Para Operador Portuário o Código de Terceiros aceito é apenas o 0131.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0651','Código de desligamento incompatível.\nAção Sugerida: Os códigos de motivos de desligamento [18,19,20,21,22,23,24, 25] só podem ser utilizados para desligamento de trabalhador pertencente à categoria de servidor público.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0652','Data incorreta.\nAção Sugerida: A data deve ser uma data posterior a data de término do contrato.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0653','A data de pagamento deve ser uma data válida compreendida no período de competência do envio do término do contrato.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0657','O Ente Federativo Responsável do Estabelecimento cadastrado na base da RFB está diferente do Ente Federativo informado no evento do Empregador.\nAção Sugerida:\nEstabelecimentos com Natureza Jurídica = [102-3, 103-1, 105-8, 106-6, 108-2, 117-1, 118-0, 123-6, 124-4], devem ter o CNPJ do Ente Federativo Responsável igual do Ente Federativo Responsável do Empregador em S-1000, observando-se o período de cadastro. Verificar se há necessidade de ajustes no cadastro do eSocial ou base da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0658','Número de inscrição inválido.\nAção Sugerida: O número de inscrição do empregador deverá ter o tamanho de 8(CNPJ base), 11(CPF) ou 14 (CNPJ) caracteres.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0659','O campo é de preenchimento obrigatório quando o motivo do afastamento for do tipo \"Licença não remunerada ou Sem Vencimento\".\nAção Sugerida: Se o Código de Motivo de Afastamento = [21] o campo é de preenchimento obrigatório, senão o preenchimento é opcional.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0660','A data informada deve ser uma data igual ou posterior a data de admissão do trabalhador e igual ou inferior à data atual.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0661','Ocorreu um erro no envio para a Caixa Econômica Federal das informações necessárias para a emissão da guia rescisória do FGTS. Clique no link para tentar novamente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0663','Tipo de Inscrição incompatível.\nAção Sugerida: Para local de ambiente igual a 1 (Estabelecimento do próprio empregador) ou igual a 3 ( Prestação de serviços em instalações de terceiros não consideradas como lotações dos tipos 03 a 09 da Tabela 10 - Tipos de Lotação Tributária), o tipo de inscrição não poderá ser igual a 2 (CPF).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0664','Lotação tributária não localizada na tabela de Lotações Tributárias do Empregador no período informado.\nAção Sugerida: Verifique as informações prestadas.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0665','Fator de risco ambiental inválido.\nAção Sugerida: Utilize um dos fatores de risco existentes na Tabela 23 (Fatores de Riscos Ambientais).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0666','Não pode haver mais de um dependente com o mesmo número do CPF',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0667','A data de admissão do trabalhador não pode ser superior a 30 (trinta) dias a partir da data atual',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0668','O trabalhador a ser substituído deverá estar cadastrado no eSocial',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0669','Tipo de provimento incompatível.\nAção Sugerida: Valor igual a [3,4,5] só é permitido se natureza jurídica do declarante for igual a {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0670','Data de posse deve ser igual ou posterior a data de nomeação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0671','Data de exercício deve ser igual ou posterior a data da posse.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0672','Salário fixo do trabalhador, correspondente à parte fixa da remuneração, incompatível com unidade de salário fixo.\nAção Sugerida: Se Unidade de pagamento da parte fixa da remuneração for igual não aplicável [7], preencher com [0] (zero) o campo Salário fixo do trabalhador, correspondente à parte fixa da remuneração.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0673','Estabelecimento não consta do cadastro de lotações tributárias do empregador no período.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0674','O término do contrato por tempo determinado não poderá exceder a 60 dias da data da admissão.\nAção Sugerida: Se o tipo de contrato for \"por prazo determinado\" = [2] e a categoria do trabalhador for \"Empregado – Trabalhador Rural por Pequeno Prazo\" [102], a data de término do contrato não poderá ser superior a 60 (sessenta) dias em relação a data de admissão.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0675','Não é permitida a exclusão de evento de admissão quando já existirem outros eventos trabalhistas para o mesmo trabalhador.\nAção Sugerida: A exclusão do evento só é permitida caso não existam outros eventos já enviados ao eSocial para o mesmo VÍNCULO TRABALHISTA.\nVerifique a existência de eventos relacionados ao vínculo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0676','Data incorreta.\nAção Sugerida: A data informada deverá ser menor ou igual da data do desligamento do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0677','Não pode existir qualquer evento para o vínculo trabalhista com data posterior a data do desligamento.\nAção Sugerida: Não deve existir qualquer evento trabalhista para o vínculo indicado no evento de desligamento com data posterior a Data de Desligamento, data final da Quarentena ou Data Projetada para o término do Aviso Prévio indenizado, quando houver; Não deve existir qualquer evento periódico com período de apuração que compreenda ou seja posterior ao mês do desligamento. A exceção a essa regra se restringe aos seguintes eventos: Monitoração de Saúde, Pagamento, Reintegração, Remuneração (em algumas situações específicas),e Alteração Contratual (quando data de efeito for igual ou anterior a Data de Desligamento, Quarentena ou Aviso Prévio indenizado).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0678','Desligamento inválido.\nAção Sugerida: Se o motivo do desligamento for Rescisão antecipada do contrato a termo [03 ou 04], o tipo de contrato indicado no evento de admissão/cadastro inicial deve ser igual a [2] - (prazo determinado), e a data de desligamento deve ser anterior a data do término prevista no contrato de trabalho.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0679','Desligamento inválido.\nAção Sugerida: Se o motivo do desligamento for rescisão por término do contrato a termo [06], o tipo do contrato indicado no evento de admissão/cadastro inicial deve ser igual a [2] (prazo determinado), e a data de desligamento deve ser igual à data do término prevista no contrato de trabalho.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0680','É necessário o envio da remuneração do trabalhador no mês imediatamente anterior a data da sua rescisão contratual antes do envio de seu desligamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0681','Identificador inválido.\nAção Sugerida: O identificador deve ser único dentro da mesma competência para cada um dos recibos de pagamento de cada trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0682','O CAEPF informado deve constar do cadastro de estabelecimentos do empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0683','Rubrica incompatível com MEI- Microempreendedor Individual.\nAção Sugerida: Se a classificação tributária do CONTRIBUINTE for relativa a MEI [04], não poderão ser aceitas rubricas cujo código de incidência de contribuições previdenciárias seja igual a [31,32].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0684','Exclusão inválida.\nAção Sugerida: Não deve ser aceita a exclusão do evento de CAT que estiver sendo referenciado por uma CAT de reabertura (campo número da CAT de origem de outro evento CAT).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0685','A data do Acidente não poderá ser posterior ao Afastamento do Trabalhador.\nAção Sugerida:\nEm caso de retificação do evento de ASO para alterar a data do acidente, verificar a existência de evento subsequente de afastamento em decorrência de acidente de trabalho, de forma a evitar inconsistência na cronologia dos eventos. (ex: acidente em jan/201x, afastamento em jan/201x por acidente de trabalho, depois tenta alterar a data do acidente do evento para mar/201x). Neste caso, ou seja, se 45 houver evento de afastamento temporário por acidente de trabalho, a data do acidente somente poderá ser retificada para uma data anterior a data do afastamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0686','O CNPJ deve estar ativo no Cadastro de CNPJ da RFB.\nAção Sugerida: O CNPJ informado deverá estar ativo ((CNPJ não poderá pertencer a pessoa jurídica Inapta (situação=4) pelo motivo de Inexistência de Fato (motivo=15)) no Sistema CNPJ, na data atual.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0687','A Data de alteração do Motivo do afastamento,deve ser igual ou posterior a data de início do afastamento que está sendo alterado e menor que a data de término do afastamento, caso esta já tenha sido informada.\nAção Sugerida: Deve ser uma data igual ou posterior a data do afastamento que está sendo alterado e menor que a data de término do afastamento, caso esta já tenha sido informada.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0688','Não é permitida a exclusão de evento para o qual já exista evento de alteração ou encerramento.\nAção Sugerida: Não deve ser aceita a exclusão do evento de afastamento se já houver evento de alteração de motivo ou de retorno respectivo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0689','Não é possível a exclusão de evento de admissão preliminar se já houver evento de admissão \"definitivo\" referenciando o mesmo evento de admissão preliminar.\nAção Sugerida: Não é possível a exclusão de evento de admissão preliminar se já houver evento de admissão \"definitivo\" referenciando o mesmo evento de admissão preliminar.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0691','Não deve existir evento de admissão parcial sem o correspondente evento de admissão cuja \"data de admissão\" seja anterior ou igual ao período de apuração da folha de pagamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0692','Para utilizar a apuração do FAP por estabelecimento é necessário informar o respectivo processo no cadastro do empregador relativo ao período de apuração.\nAção Sugerida: O campo Indicativo de Apuração da Aliquota FAP somente pode ser igual a [2] se houver informação sobre a existência de processo judicial relativo ao FAP (grupo Processo administrativo/judicial relativo ao FAP) nas informações do empregador relativas ao período de apuração.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0693','A Data de Adesão Antecipada informada, deverá estar entre {0} e a data de início de obrigatoriedade do empregador ao eSocial.\nAção Sugerida: Deve ser uma competência anterior ao início de sua obrigatoriedade ao eSocial e igual ou posterior à data de início de obrigatoriedade ao eSocial para os primeiros empregadores.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0694','A data informada de encerramento de folha, deverá ser maior que o período da última folha de pagamento encerrada.\nAção Sugerida: A data informada não pode ser menor ou igual à última competência para a qual já tenha sido transmitido evento S-1299 (Fechamento dos Eventos Periódicos).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0695','Já existe uma admissão preliminar para o trabalhador sem a respectiva admissão definitiva. Neste caso a admissão preliminar que encontra-se \"aberta\" deve ser excluída.\nAção Sugerida:\n. Não é permitido o envio de evento para trabalhador (CPF) para o qual já exista evento de admissão preliminar sem o respectivo evento de admissão definitivo (S-2200).\n. O vínculo do evento de admissão preliminar (S-2190) com a admissão definitiva (S-2200) é feito pelo campo Número do Recibo de Informação Preliminar onde é informado o número do recibo de entrega do evento de admissão preliminar.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0696','Estabelecimento não existe no cadastro do empregador.\nAção Sugerida: Se pessoa jurídica, a inscrição informada deve constar na Tabela de estabelecimentos (S-1005).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0697','O CNPJ não deve estar cadastrado na Tabela de Estabelecimentos e Obras no período especificado.\nAção Sugerida: O CNPJ informado NÃO deve existir na Tabela de Estabelecimentos e Obras (evento S-1005) no período especificado, favor verificar.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0698','A data do desligamento deve ser anterior ao término do contrato de trabalho.\nAção Sugerida: Se o motivo do desligamento for igual a [04], conforme Tabela 19 (Motivos de Desligamento), a data de desligamento também deve ser anterior a Data de Término (se a mesma foi informada).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0699','Não foi localizada uma admissão preliminar correspondente ao número de recibo informado, para o mesmo trabalhador, data de nascimento e data de admissão.\nAção Sugerida: Deve existir um evento de Admissão preliminar com número de recibo de entrega igual ao informado no campo. As informações de CPF, Data de Nascimento e Data de Admissão do evento de Admissão Preliminar identificado, devem ser iguais às informações prestadas no evento de admissão para o trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0700','O campo deverá ser preenchido sempre que existir uma Admissão Preliminar para o trabalhador para a qual não exista uma Admissão correspondente.\nAção Sugerida: O campo é obrigatório se existir um Evento de Admissão Preliminar para o mesmo TRABALHADOR e que não tenha evento de admissão correspondente. O número do recibo de entrega existente é: {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0702','O FPAS não é compatível com a classificação tributária do Contribuinte.\nAção Sugerida: O valor do FPAS informado deverá ser compatível com a classificação tributária do Contribuinte do evento S-1000, conforme Tabela 22 (Compatibilidade entre FPAS e Classificação Tributária).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0705','A categoria informada dever ser diferente de trabalhador cedido.\nAção Sugerida: O código da categoria informado não poderá pertencer ao grupo \"Trabalhador Cedido\" conforme Tabela 1 (Categorias de Trabalhadores).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0707','Não foi localizado o contrato de trabalho ativo do dirigente sindical na empresa de origem informada.\nAção Sugerida: Se a categoria original indicada no campo \"categoria de origem do dirigente sindical\" for relativa a \"empregado\", deverá existir um VINCULO TRABALHISTA ATIVO para o trabalhador indicado nos campos CNPJ de Origem + CPF do trabalhador + Matrícula de Origem + Data de Admissão de Origem do grupo Informação Dirigente Sindical na data informada no campo Data de Início do grupo Informação TSV (Trabalhador Sem Vínculo) Inicio.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0708','A data de pagamento deve estar compreendida no período de apuração.\nAção Sugerida:\nA data de pagamento deve estar compreendida no período de apuração ao qual se refere o arquivo.\nSe Indicativo de Apuração igual a:\n1 : o mês/ano da data de apuração deve ser igual ao mês/ano do perído de Apuração;\n2 : o ano da data de apuração deve ser igual ao ano do período de apuração.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0709','A data deve ser menor ou igual ao período de apuração.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0710','No mesmo Recibo de Pagamento (contracheque/holerite) não podem constar simultaneamente rubricas de caixa (faixa 8000) e rubricas de competência (demais faixas) da mesma natureza.\nAção Sugerida: Para o mesmo Identificador de Recibo de Pagamento não podem constar simultaneamente rubricas de caixa (faixa 8000) e rubricas de competência (demais faixas) da mesma natureza.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0711','A data de início foi preenchida automaticamente pelo sistema com base na data corrente, como sugestão. \nAção Sugerida: Caso deseje alterá-la, leia as instruções de preenchimento antes de prosseguir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0712','O Sr./Sra. Contribuinte foi identificado como Segurado Especial, a partir das informações do Sistema CAEPF. A data início de validade foi preenchida inicialmente com base na data de criação do CAEPF e início de obrigatoriedade do eSocial, como sugestão. \nAção Sugerida: Caso deseje alterá-la, leia as instruções de preenchimento antes de prosseguir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0713','A data início de validade foi preenchida inicialmente com base na data de criação da empresa, obtida no Sistema CNPJ, e início de obrigatoriedade do eSocial, como sugestão. Caso deseje alterá-la, leia as instruções de preenchimento antes de prosseguir.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0714','Não foi possível atualizar o cadastro do Empregador, pois existem informações geradas após a data de atualização. Nessa situação, o Sr./Sra. Contribuinte poderá optar por retificar e/ou excluir as informações na opção Dados do Empregador > Visualizar Cadastro do Empregador por Períodos de Validade. Ainda, se desejar, poderá cadastrar um novo período para qual o não haja informações na opção Dados do Empregador > Alterar Cadastro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0715','A folha de pagamento do período {0} já está aberta.\nAção Sugerida: Permitir que o contribuinte envie os eventos que irão compor sua folha de pagamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0716','O CPF/CNPJ vinculado ao Sr./Sra. Contribuinte encontra-se na lista de obrigatoriedade ao eSocial gerada pela RFB. Por isso, a data início de validade ao eSocial foi preenchida automaticamente com a data que consta na lista. Para mais informações sobre o preenchimento, verifique as orientações abaixo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0717','O tipo de inscrição igual a CNPJ somente poderá ser utilizado por empregador PJ.\nAção Sugerida: O campo somente poderá ser preenchido com 1 se o campo Tipo de Inscrição for igual a 1 (CNPJ).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0718','O Valor Ajustado deve corresponder ao Valor Líquido/0,65.\nAção Sugerida: Valor informado no campo deverá corresponder ao valor líquido dividido por 0,65.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0719','Para que o Sr./Sra. Contribuinte possa registrar os eventos no eSocial a partir da data de adesão informada é necessário alterar a data inicial das informações cadastrais do Empregador. Deseja que o sistema altere os dados automaticamente? Caso opte por não atualizar o cadastro neste momento, poderá fazê-lo acessando a opção > Dados do Empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0720','Para que o Sr./Sra, Contribuinte possa registrar os eventos no eSocial a partir da data de adesão informada é necessário que exista informações cadastrais do Empregador a partir dessa data. Registre ou retifique as informações de período de validade do Cadastro do Empregador, acessando a opção > Dados do Empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0721','Não foi possível registrar o evento atual pois existe(m) evento(s) cadastrado(s) com data de ocorrência posterior para esse trabalhador que se tornarão inconsistentes em caso de recepção deste. Para que seja possível esse registro, executar os seguintes passos:\na) Excluir os eventos identificados com data posterior ao evento que se pretende informar;\nb) Fazer o registro do evento conforme pretendido;\nc) Informar novamente em ordem cronológica os eventos excluídos, se continuarem válidos.\nConsultar o Manual para obter orientações sobre consulta e exclusão e recepção de eventos extemporâneos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0722','Os tipos de reintegração 3, 4 e 5 só podem ser informados por órgãos públicos.\nAção Sugerida: O campo não pode ser informado com valor [3, 4, 5] quando o contribuinte for diferente de Administração Pública.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0723','Valor Líquido inválido. O valor esperado do trabalhador CPF: {0} é: ({1}).\nAção Sugerida:\nEm caso de pagamento total, o valor líquido deve corresponder ao somatório dos valores de vencimentos e descontos da remuneração e também dos vencimentos e descontos de IRRF e Pensão alimentícia. Em caso de pagamento parcial, o valor líquido deve corresponder ao somatório dos valores de vencimentos e descontos informados no grupo infoPgtoParc.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0724','Não foi localizado um evento de remuneração do trabalhador para o período e com mesmo demonstrativo de pagamento.\nAção Sugerida:\nDeve ser um valor atribuído pela fonte pagadora em S-1200, S-1202 ou S-1206 no campo \"Identificador de Recibo de Pagamento\", obedecento a relação:\n.Se Tipo de Pagamento = [1], em S-1200;\n.Se Tipo de Pagamento = [5], em S-1202;\n.Se Tipo de Pagamento = [7], em S-1206.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0725','O valor do pagamento efetuado deve ser menor ou igual ao valor pago para o recibo de pagamento informado na rescisão contratual ({0}).\nAção Sugerida:\nO valor informado deve ser menor ou igual ao valor do pagamento apurado do evento S-2299 ou S-2399, que corresponda ao respectivo recibo identificado em \"Identificador de Recibo de Pagamento\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0726','Não foi localizado um evento de rescisão contratual para o trabalhador com mesmo recibo de pagamento.\nAção Sugerida:\nDeve ser um identificador de recibo de pagamento atribuído pela empresa em um dos eventos rescisórios (S-2299 ou S-2399), no campo \"identificador de recibo de pagamento\".\n.Se Tipo de Pagamento = [2] deve ser um valor atribuído pela empresa em S-2299;\n.Se Tipo de Pagamento = [3], deve ser um valor atribuído pela empresa em S-2399.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0727','Não foi localizado um evento de rescisão contratual para o trabalhador com mesmo recibo de entrega.\nAção Sugerida:\nDeve ser um número de recibo de arquivo válido, relativo a um dos leiautes S-2299 ou S-2399.\n.Se Tipo de Pagamento = [2] deve ser um recibo de arquivo gerado no leiaute S-2299.\n.Se Tipo de Pagamento = [3], deve ser um recibo de arquivo gerado no leiaute S-2399.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0728','O regime de jornada de trabalho do empregado selecionado não exige informações de jornada de trabalho.\nAção Sugerida: Os dados serão informados somente quando o regime de jornada de trabalho do empregado for igual \""1-Submetidos a Horário de Trabalho (Cap. II da CLT)\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0729','O campo deve estar preenchido com {0} caracteres.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0730','O valor informado deve existir na tabela de ambientes de trabalho do empregador.\nAção Sugerida:\nO valor informado no campo deverá existir no Evento de Tabela de Ambientes de Trabalho.\nPara obter informações que constam de tabelas e eventos cadastrais deverá ser considerado o período de validade da informação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0731','O fator de risco deve existir na tabela de ambientes de trabalho do empregador vinculado ao mesmo ambiente de trabalho.\nAção Sugerida: O valor informado no campo código do fator de risco deverá existir no Evento de Tabela de Ambientes de Trabalho vinculado ao campo Código do Ambiente de trabalho, para o mesmo CONTRIBUINTE.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0732','Existe um evento de Condição Ambiental de Trabalho para o mesmo ambiente e descrição de atividade para o qual não houve um evento de término.\nAção Sugerida: Não é 50 permitido o envio de evento de Condições Ambientais de Trabalho - Início se já houver evento idêntico para o mesmo vínculo com data anterior e sem o respectivo evento indicando o término da condição.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0733','Para a contratação de trabalhador com data de admissão anterior à data início de obrigatoriedade do contribuinte no eSocial, é necessário que haja informações cadastrais do empregador desde essa data.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0734','Existe um evento de Insalubridade e Periculosidade para o mesmo ambiente para o qual não houve um evento de término.\nAção Sugerida: Não é permitido o envio de evento de Insalubridade e Periculosidade - Início se já houver evento idêntico (mesmo codigo de Ambiente de Trabalho) para o mesmo vínculo com data anterior e sem o respectivo evento indicando o término.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0735','Existe um evento de Aposentadoria Especial para o mesmo ambiente para o qual não houve um evento de término.\nAção Sugerida: Não é permitido o envio de evento de Aposentadoria Especial - Início se já houver evento idêntico (mesmo codigo de Ambiente de Trabalho) para o mesmo vínculo com data anterior e sem o respectivo evento indicando o término.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0736','Não foi localizado um evento de início de Insalubridade e Periculosidade para o vínculo trabalhista.\nAção Sugerida:\nPara aceitação do evento de alteração ou de término de \"Condições Ambientais do Trabalho\" é necessária a existência do respectivo evento de INÍCIO para o mesmo vínculo, grupo de informações (insalubridade /periculosidade ou aposentadoria especial) e ambiente em data anterior a data do evento, e para o qual ainda não conste o respectivo evento de TÉRMINO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0737','Não foi localizado um evento de início de Aposentadoria Especial para o vínculo trabalhista.\nAção Sugerida:\nPara aceitação do evento de alteração ou de término de \"Condições Ambientais do Trabalho\" é necessária a existência do respectivo evento de INÍCIO para o mesmo vínculo, grupo de informações (insalubridade /periculosidade ou aposentadoria especial) e ambiente em data anterior a data do evento, e para o qual ainda não conste o respectivo evento de TÉRMINO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0739','Atenção Sr./Sra. Empregador ao limite de 120 dia/ano para contratação de trabalhadores no ano corrente. Para mais informações e regularização dos dados cadastrais, procure uma das Unidades Conveniadas da Secretaria da Receita Federal do Brasil. Saiba mais.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0740','Foi identificado na base de dados do eSocial um lote em processamento idêntico ao que está sendo transmitido. O Lote que consta da base de dados do eSocial possui o número de protocolo : {0}, será necessário aguardar o processamento deste lote.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0741','O evento não pertence ao grupo informado no lote. Dúvidas sobre o grupo de cada evento consulte o manual do usuário disponível no sítio do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0742','Ocorreu uma falha ao obter as informações vinculadas ao CPF do Empregador no Sistema CAEPF. \nAção Sugerida: Aguarde alguns minutos e tente novamente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0743','A data de início no eSocial deve corresponder à data que consta na lista de obrigatoriedade do eSocial gerada pela RFB: {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0744','A data de início de validade mínima deve corresponder à data de Inicio do eSocial: {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0745','A data de início de validade mínima deve corresponder à data de abertura da Empresa vinculada a este CNPJ: {0}.\nAção Sugerida:\nO empregador (CNPJ) que não constar na lista de obrigatoriedade ao eSocial gerada pela RFB, deverá informar como data mínima das informações no eSocial a data de criação da empresa ou a data de primeiro vínculo (a que ocorrer primeiro), quando ambas forem superior em à data de início do eSocial.\nCaso uma das datas seja anterior à data de inicio do eSocial, deverá informar como data mínima, a data de início do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0747','Os dados das [verbas rescisórias/verbas da remuneração] informadas serão perdidos quando alterada a opção de preenchimento. Deseja continuar?',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0748','O protocolo informado é inválido.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0749','O protocolo informado foi emitido em outro ambiente do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0750','O período de validade do item não pode ser diminuído, pois este item está sendo utilizado em outro evento já enviado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0751','A natureza jurídica não é compatível com a classificação tributária do empregador.\nAção Sugerida:\nSe Classificação tributária igual a Ente Federativo, Orgãos da União, Autarquias e Fundações Públicas = [85], o número da natureza jurídica deve iniciar por 1 (exemplo: 101-5, 112-0, etc.).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0752','O campo somente poderá ser preenchido por empregador PJ e mediante informação de processo administrativo/judicial.\nAção Sugerida:\nA informação do FAP por estabelecimento só é permitida se houver processo administrativo/judicial correspondente. Deve existir o registro complementar com informações sobre o processo administrativo/judicial que permite a aplicação de alíquotas diferenciadas por estabelecimento. Não pode ser informada pela Pessoa Física.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0753','O tipo de CAEPF informado está diferente do valor encontrado no Sistema CAEPF.\nAção Sugerida: Efetue a regularização.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0754','Este tipo de pagamento é de uso exclusivo de órgão público.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0755','Este demonstrativo de pagamento já consta como pago no mês {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0756','A admissão preliminar correspondente a este recibo de entrega já foi utilizada por outra admissão definitiva.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0757','Alteração não permitida.\nAção Sugerida: Só é possível alteração de categoria de trabalhadores nas seguintes opções: de [102, 103, 105, 106, 111] para [101] ou de [101] para [111]. Não pode alterar a categoria para os demais casos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0758','Categoria informada não é compatível com "Trabalhador sem Vínculo". \nAção Sugerida: Para aceitação do evento devem ser observadas as seguintes regras de compatibilidade entre a categoria de trabalhador e o evento utilizado: O evento S-2300 somente é aceito para as categorias de trabalhadores igual a [201, 202, 305, 308, 401, 410, 701, 711, 712, 721, 722, 723, 731, 734, 738, 741, 751, 761, 771, 781, 901, 902, 903, 904, 905].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0759','Se a data de admissão for entre 01/01/1967 e 04/10/1988, a data de opção deverá ser maior ou igual a data de admissão e menor ou igual a 05/10/1988.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0760','Percentual inválido.\nAção Sugerida: O valor informado deve ser menor ou igual a 100.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0761','Não foi localizada a remuneração do trabalhador CPF: {0} Matrícula {1} no período.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0762','Não é possível realizar essa operação, pois irá gerar contratos simultâneos para o trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0763','Indicativo de Depósito do Montante Integral inválido.\nAção Sugerida: Se já houve decisão definitiva favorável ao contribuinte não cabe a indicação de depósito. Ou caso o motivo da suspensão seja por depósito o indicativo de depósito deve ser preenchido com "Sim".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0764','Este evento de remuneração não pode ser utilizado para esta categoria de trabalhador.\nAção Sugerida:\nO evento S-1200 só pode ser aceito para trabalhadores amparados pelo Regime Geral de Previdência Social – RGPS. Para as categorias 301 a 309 deve ser usado o evento S-1202.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0765','O recibo selecionado já possui uma data efetiva de pagamento, logo, se tratar de pagamento de valores complementares, a opção correta é incluir um novo recibo, contendo o valor a ser pago. Realmente deseja retificar os valores desse recibo?',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0766','Após reabrir a folha de pagamento, será necessário encerrá-la novamente quando finalizar as alterações necessárias. Deseja continuar?',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0767','O empregado selecionado possui data prevista de término do contrato nesta competência. Atualize a data no cadastro do empregado em caso de prorrogação do contrato ou registre o desligamento para informar as verbas rescisórias.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0768','Sr. Empregador, existem recibos de pagamento, relativo à remuneração de competências anteriores, sem informação de data de pagamento. Acesse: \"Pagamentos realizados\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0769','O valor do adiantamento deve ser maior que zero e o total de adiantamentos não pode ser superior ao salário recebido pelo trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0770','A data do adiantamento deve ser uma data compreendida no mês referente à folha de pagamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0771','Sr. Empregador, a folha encontra-se encerrada, Para incluir, alterar ou excluir quaisquer dados será necessário reabri-la.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0772','Sr. Empregador, as informações prestadas têm caráter declaratório e constituem instrumento hábil e suficiente para a exigência dos tributos e encargos apurados conforme previsto no art. 32 - C da Lei nº 8.212 de 24 de julho de 1991 com a redação dada pela Lei nº 12.873 de 24 de outubro de 2013.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0773','Falha ao confirmar o fechamento da folha para o Sistema DCTF Web ({0} - {1}).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0774','O limite de {0} é {0}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0775','Para liberar os valores das rubricas para edição, serão descartados os dados informados no apurador de horas. Deseja continuar mesmo assim?',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0776','O NSU {0} é uma lacuna do sequenciamento e não possui evento associado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0777','O valor informado deve ser inferior a 365 dias.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0778','O intervalo entre as datas informadas nos campos {0} e {2} deve ser igual ou superior a 30 dias.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0779','A soma dos valores informados nos campos \"Quantidade de Dias de Gozo de Férias\" do primeiro período e do segundo período deve ser igual ao valor informado no campo \"Quantidade de Dias de Férias Disponíveis\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0780','A data {0} deve está dentro do intervalo {1} e {2}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0781','A data informada deve ser um dia útil, ou seja, não deve é sábado, domingo ou feriado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0782','Não existe Aviso de Férias registrado no sistema para o período selecionado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0783','Não existe saída de férias registrada no sistema para o período selecionado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0784','A quantidade de dias de férias em 1 (um) dos períodos deve ser, no mínimo, 14 (quatorze) dias corridos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0785','O empregado não tem direito a férias pois o mesmo ficou afastado, devido ao motivo {0}, em um período superior a {1} dias.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0786','A data de início do período de férias está dentro do período aquisitivo do empregado e não está de acordo com legislação. Deseja Continuar?',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0787','A data de início/término do período de férias é posterior a data de término do período de concessão. Deseja Continuar?',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0789','Código Inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 17 (Descrição da Natureza da Lesão).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0790','Código Inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 23 (Fatores de Riscos Ambientais).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0808','As informações prestadas no detalhamento dos pagamentos efetuados relativos a folha que se referem a competência: {0} e número de recibo: {1} estão em duplicidade.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0809','As informações prestadas no detalhamento dos pagamentos efetuados relativos a rescisões contratuais que se referem ao número de recibo: {0} estão em duplicidade.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0814','O Valor informado deve ser maior ou igual à ZERO.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0815','Quando se tratar de folha de pagamento mensal o mês/ano de apuração deverá ser menor ou igual a data atual, exceto quando utilizando a aplicação web do eSocial quando poderá ser dois meses após o mês/ano atual. Para folha de pagamento de décimo terceiro o 55 ano de apuração deverá ser menor ou igual ao ano corrente.\nAção Sugerida: Se Indicativo de período de apuração for igual a [1] (mensal), o mês/ano do período de apuração deverá ser menor ou igual a data atual, exceto quando utilizando a aplicação web do eSocial quando poderá ser dois meses após o mês/ano corrente . Se Indicativo de período de apuração for igual a [2] (décimo terceiro), o ano do período de apuração deverá ser igual ou inferior ao ano corrente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0819','O CPF do dependente não pode ser igual ao CPF do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0823','Data inválida.\nAção Sugerida: Deve ser uma data válida, posterior a data de desligamento do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0841','A categoria deste trabalhador somente aceita natureza da atividade de trabalho urbano.\nAção Sugerida: altere a natureza da atividade para \"Trabalho Urbano\" ou a categoria do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0842','Se a alteração de motivo foi de 1 para 3 ou de 3 para 1, a data de alteração deve ser igual à data do afastamento inicial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0843','Se a alteração do código de motivo de afastamento é de 1 para 3 ou de 3 para 1 o indicativo de efeito retroativo deve ser preenchido com \"Sim\".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0846','O somatório de cada um dos descontos de Contribuição Previdenciária (codIncCP = [31, 32, 34, 35]) e de IRRF (codIncIRRF = [31, 32, 33, 34, 35]) não pode ser negativo, ou seja, os vencimentos não podem ser superiores aos descontos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0847','Não podem ser utilizadas rubricas cujo codIncIRRF em S-1010 seja igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0848','Só pode ser utilizada rubrica cujo codIncIRRF em S-1010 seja igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0849','O valor informado deve corresponder ao somatório das pensões dos respectivos beneficiários.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0851','A exclusão de remuneração e desligamento não é aceita quando houver pagamento relacionado.\nAção Sugerida: Antes de excluir a remuneração ou desligamento exclua as informações de pagamento relacionadas.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0852','A informação contida no campo {0} deve possuir o mesmo valor em todo o período do evento, em relação à origem do seu cadastro (eventos do empregador, tabelas, sistemas externos, tabelas de referências, etc).\nAção sugerida: Corrigir o valor do campo 56 ou o período da informação no evento, ou providenciar o acerto da informação contida no campo no seu cadastro de origem.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0860','A data de pagamento deve ser maior ou igual ao período de apuração da remuneração.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0861','A data de pagamento deve ser maior ou igual ao mês anterior de rescisão do contrato de trabalho.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0879','A informação de depósito judicial somente se aplica à processo do próprio contribuinte.\nAção Sugerida: Se a autoria do processo não se refere ao próprio contribuinte informe "Não".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0880','O tipo de inscrição 2-CPF somente pode ser utilizado por empregador doméstico.\nAção Sugerida: Para empregador pessoa física utilize [3 ou 4]. Para empregador pessoa jurídica utilize [1 ou 4].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0882','Tipo de dependente inválido.\nAção Sugerida: o valor informado deve existir na Tabela de Tipos de Dependentes.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0883','{0} inválida.\nAção Sugerida: A data não pode ser superior à data atual, exceto se o motivo do afastamento for férias, situação em que pode ser até 60 dias superior à data atual.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0884','Tipo de Acidente de Trabalho inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 24 (Codificação de Acidente de Trabalho).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0886','{0} inválida.\nAção Sugerida: Deve ser uma data não superior à data atual acrescida de 10 dias corridos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0890','Rubrica incompatível.\nAção Sugerida: Utilize somente rubricas cujo código de incidência do FGTS seja compatível com evento de remuneração (código de incidência do FGTS diferente de 21).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0892','Certidão de óbito inválida.\nAção Sugerida: O número de certidão informado não é compatível com a regra de formação do número.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0896','CNPJ inválido. Ação: O CNPJ do estabelecimento deve possuir 14 dígitos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0897','Código de Terceiros para os quais o recolhimento está suspenso inválido.\nAção Sugerida: Deve haver um processo para cada código de Terceiro cujo recolhimento esteja suspenso.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0898','Iniciativa pela emissão do CAT inválida.\nAção Sugerida: A iniciativa de emissão deve ser preenchida com 1 - Iniciativa do Registrador quando o registrador não for o próprio empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0900','Data do óbito inválida. \nAção Sugerida: Deve ser uma data igual ou posterior a data do acidente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0901','Dependente inválido.\nAção Sugerida: O dependente deve constar do cadastro do trabalhador no eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0902','Já foi iniciado o processo de encerramento da folha de pagamento. Nenhum evento deste empregador poderá ser recebido até que o processo seja concluído.\nAção Sugerida: Aguarde a conclusão do processamento do evento de fechamento da folha; caso seja necessário, reabra a folha e reenvie os eventos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0908','Tipo de Estabelecimento inválido.\nAção Sugerida: Para empregador segurado especial o tipo de estabelecimento deve ser preenchido com "3- CAEPF".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0910','O evento não pode ser recebido. O número do processo está sendo utilizado em outro evento e pode gerar inconsistência.\nAção Sugerida: Verifique se o código de Suspensão é o mesmo no evento onde está sendo utilizado, e se o período o abrange.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0911','Data/Período inválido.\nAção Sugerida: a data/período informado deve ser anterior ao início de obrigatoriedade do empregador ao eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0917','A informação no campo que indica se o Órgão Público é uma Entidade Federativa Responsável está divergente do Sistema CNPJ da RFB.\nAção Sugerida: Corrija a informação ou compareça à unidade local da RFB para regularizar a situação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0918','O CNPJ do Ente Federativo Responsável preenchido está divergente do CNPJ cadastrado no Sistema CNPJ da RFB.\nAção Sugerida: Corrija a informação ou compareça à unidade local da RFB para regularizar a situação.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0922','A {0} deve ser igual ou posterior a data de admissão ou, caso preenchido o grupo "sucessaoVinc", igual ou posterior a data inicial do vínculo e anterior ao início do eSocial.\nAção Sugerida: O valor informado no campo deverá ser maior ou igual a data de admissão e menor que a data de início de obrigatoriedade do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0923','Carreira não existe no cadastro do empregador. Ação Sugerida: O valor informado no campo de Código da Carreira deverá existir na Tabela Tabela de Carreiras Públicas, informada pelo empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0924','CNPJ inválido. O CNPJ deve ter a mesma Raiz/Base de oito posições da empresa da qual o trabalhador temporário está alocado.\nAção Sugerida: Corrigir CNPJ, mantendo o mesmo Base do estabelecimento onde o trabalhador está vinculado e alocado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0927','Evento não é aceito para o empregador.\nAção Sugerida: Verifique se o evento é compatível com a classificação tributária do empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0930','Não é possível cadastrar o Empregador. O CNPJ do Órgão Público não corresponde a uma Matriz no Cadastro da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0933','O somatório dos Proventos deve ser maior ou igual ao somatório dos Descontos no Demonstrativo de Pagamento {0}. Valor Encontrado: {1}.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0932','Só pode ser utilizada rubrica cujo codIncIRRF em S-1010 seja igual a [00, 01, 09, 13, 33, 43, 46, 53, 63, 75, 93].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0942','A data de início do afastamento deve ser maior ou igual à data de início do vínculo da sucessão e menor que a data de admissão do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0943','Pelo menos um dos campos [vrRatSusp], [vrSenarSusp] ou [vrCPSusp] deve ser preenchido.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0951','A folha de pagamento do período {0} não possui nenhum evento e nem se encontra fechada, portanto não é possível reabri-la.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0956','A categoria deste trabalhador somente aceita natureza da atividade de trabalho rural.\nAção Sugerida: altere a natureza da atividade para \"Trabalho Rural\" ou a categoria do trabalhador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0957','Data inválida.\nAção Sugerida: A data deve estar compreendida no mês em que ocorreu o desligamento ao qual se refere o arquivo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0965','A data deve ser menor ou igual ao mês da data do desligamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0973','Período inválido.\nAção Sugerida: Informar o período ao qual se refere o complemento de remuneração, no formato MM/AAAA (Aplicação Web) ou AAAA-MM (Webservices).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0974','Data do efeito inválida.\nAção Sugerida: A data do efeito deve ser maior ou igual à data de admissão do vínculo trabalhista, ou da data de início do vínculo trabalhista na primeira empresa, quando houver mais de uma empresa na cadeia sucessória.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0975','O envio de remuneração anual só é permitido a partir do mês de dezembro do ano corrente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0976','O campo é de preenchimento obrigatório quando no evento de admissão indicar que o evento não se refere a um cadastramento inicial de vínculo (cadIni=\"N\").',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0980','A data informada deve ser maior que 01/01/1900 e anterior à data atual.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0987','Rubrica possui código de incidência previdenciária incompatível com categoria do trabalhador.\nAção Sugerida: Verificar a incidência de contribuição previdenciária da rubrica: não pode ser utilizada, para contribuinte individual e bolsistas, rubricas com codIncCP = [25, 26, 51].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0989','Não é possível retificar o evento. Existe evento de pagamento associado que será impactado pelo evento retificador. Recibos impactados: {0}.\n Ação Sugerida: Retificar ou excluir o evento de Pagamento que contenha o demonstrativo de pagamento que está causando a inconsistência e tentar enviar o evento novamente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0990','O empregado só pode ser admitido afastado quando vier de uma sucessão (tpAdmissao=[2, 3, 4]).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0991','A data informada deverá ser maior ou igual ao período de apuração informado em "perApur".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'0992','CPF inválido. O CPF informado deve existir no RET para todo pagamento de férias (grupo detPgtoFer) e, exceto quando se referir a TSVE, para pagamentos de competências anteriores ao início de obrigatoriedade dos eventos periódicos (grupo detPgtoAnt).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1001','Regime Previdenciário inválido.\nAção Sugerida: Quando categoria do trabalhador igual a doméstico, o tipo de regime previdenciário deve ser RGPS.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1002','Regime Trabalhista inválido.\nAção Sugerida: Quando categoria do trabalhador igual a Doméstico, o tipo de regime trabalhista deve ser Celetista.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1003','A data deverá ser maior ou igual à data de admissão do trabalhador ou data de início do vínculo do trabalhador na empresa sucedida.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1008','A data informada deverá ser maior ou igual ao mês da data do desligamento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1009','A data informada deverá ser maior ou igual a 01/01/1967 e menor ou igual a 04/10/1988.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1010','A data de Admissão do trabalhador para categoria 105 deve ser maior ou igual a 22/01/1998.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1011','Não é possível receber evento de Solicitação de Totalização para Pagamento em Contingência. Sua utilização é restrita e deve atender a algumas regras.\nAção sugerida: Observar o atendimento das regras: Somente pode ser enviado até três (3) vezes por período de apuração; Sua aceitação só é possível caso não sejam satisfeitas as regras estabelecidas para o evento S-1299; Só é aceito entre os dias 01 e 20 do mês subsequente ao do período de apuração, no caso de apuração mensal , e entre os dias 01 e 20 de dezembro, no caso de folha de pagamento anual; Deve haver movimento na folha da competência a que se refere o respectivo evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1012','O Empregador {0} foi removido com sucesso da base de dados da produção restrita do eSocial.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1013','Rubrica {0} inválida.\nAção Sugerida: As rubricas que compõem o pagamento parcial devem integrar o demonstrativo de valores devidos do trabalhador em (S-1200, S-1202, S-2299, S-2399, S-1207) ou possuir incidência (codIncIRRF) em S-1010 igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1017','CNPJ do {0} inválido.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1018','CNPJ do {0} não consta no cadastro da RFB. ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1019','CPF do {0} inválido.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1020','CPF do {0} não consta no cadastro da RFB. ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1024','Número do Benefício inválido.\nAção Sugerida: Verifique se as informações do número do benefício e tipo do processo estão corretas. ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1025','Indicativo da matéria do processo ou alvará judicial inválido.\nAção Sugerida: Quando tipo do Processo for igual a[3](Número do Benefício), o Indicativo de Matéria do Processo deverá ser igual a 6]. ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1026','Verifique os dados informados pois apresentam divergência entre CPF e NIS, ou o NIS não é o mesmo que foi informado em sua admissão/inicío de TSVE ou em sua última alteração cadastral. ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1027','Não foi encontrado o desligamento do empregado doméstico transferido no Empregador de origem a partir das informações prestadas.\nAção Sugerida: Verifique se existe um desligamento para o Empregador de origem, com mesmo cpf, matrícula, e cuja data de desligamento seja imediatamente anterior à data da transferência.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1028','Tipo de Admissão inválida.\nAção Sugerida: Para transferir empregado doméstico para outro representante da mesma unidade familiar, o código da categoria do trabalhador deve ser [104], e a Admissão só pode ser efetivada via eSocial Doméstico Web.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1029','A data deverá ser posterior à data de admissão do trabalhador. ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1030','Tipo de Contrato em tempo parcial inválido.\nAção Sugerida: Verificar o tipo de contrato de acordo com a categoria: o código (1) só é válido se codCateg = (104). Os códigos (2, 3) não são válidos se codCateg = (104).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1031','Não é possível efetivar a alteração do contrato de trabalho.\nAção Sugerida: A alteração da categoria do trabalhador de [111] para [101] não é permitida quando existe evento de Convocação para Trabalho Intermitente com data maior ou igual a data da alteração do contrato de trabalho.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1032','Não é possível receber o evento.\nAção Sugerida: Verifique a categoria do trabalhador.A recepção do Evento de Convocação para Trabalho Intermitente só é permitida para trabalhadores com categoria 111 em todo o período vigente. ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1033','Motivo do Desligamento inválido.\nAção Sugerida: Para realizar Transferência de titularidade do empregado doméstico para outro representante da mesma unidade familiar, a categoria do trabalhador deve ser 104.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1035','Código de Convocação para Trabalho Intermitente não existe no eSocial para o empregado.\nAção Sugerida: O valor informado no campo deverá existir no evento de Convocação para Trabalho Intermitente, para o empregado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1036','A data de nascimento do novo titular está diferente do valor encontrado no Sistema da RFB.\nAção Sugerida: Procure unidade conveniada da RFB e efetue a regularização.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1038','O NIS informado é inválido.\nAção Sugerida: Verifique os dados informados pois apresentam divergência entre o NIS informado no evento objeto de exclusão, e o NIS informado neste evento.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1039','Data de Nascimento cadastrada no eSocial inválida.\nAção Sugerida: Verifique se a data de nascimento previamente cadastrada no eSocial está correta.Ela deve ser igual à data de nascimento informada no cadastro do trabalhador nas bases da RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1040','Número de Processo Inválido.\nAção sugerida: Certificar que este tipo de processo pode ser utilizado para suspensão de débitos tributários perante a RFB.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1041','Certidão de Óbito inválida.\nAção Sugerida: Só é possível utilizar números de certificado de óbito que possuam o 15o dígito igual a [4, 7].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1061','Não é possível aceitar o evento S-1295. O número máximo de envios para o período de apuração foi atingido. O número máximo de envios com sucesso é 3 (três).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1062','Não é possível aceitar o evento S-1295. Não existem pendências que impedem o fechamento da folha.\nAção Sugerida: Enviar o evento S-1299.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1063','Não é possível aceitar o evento S-1295. O período para envio do evento não é válido. Só é permitido envio entre os dias 01 e 20 do mês subsequente ao período de apuração quando apuração mensal, e envio entre os dias 01 e 20 de dezembro para apuração anual.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1064','Não é possível aceitar o evento S-1295. Não há movimento na folha do período.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1071','O código de terceiro informado deve ser igual a "0000".',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1073','A data deve ser menor que a data de transferência do empregado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1074','Não é possível enviar uma admissão com grupo "afastamento"/"desligamento" após início de obrigatoriedade no eSocial, a menos que o empregado venha de uma transferência/sucessão.\nAção Sugerida: Enviar o evento de admissão e posteriormente enviar o evento de afastamento/desligamento, separado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1075','A data de término do afastamento não pode ser superior à data atual acrescida de 15 dias corridos, exceto se motivo do afastamento é férias, situação em que pode ser até 60 dias superior à data atual.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1076','O CNPJ do certificado não corresponde com os CNPJS (Matriz e filial) retornados pela integração.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1085','O número do processo é inválido.\nAção Sugerida: Verificar o tamanho do processo de acordo com o tipo: processo judicial deve ter tamanho fixo de 20 algarismos, processo administrativo tamanho de 17 ou 21 algarismos, Número de Benefício tamanho fixo de 10 algarismos e Processo FAP de tamanho fixo de 16 algarismos.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1087','Os eventos de um período contratual não podem ter suas datas de ocorrência retificadas de modo que sejam deslocados do período anterior ao desligamento ao período posterior à reintegração e vice-versa.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1088','A data deverá ser maior ou igual à data de admissão do trabalhador//Data de início do contrato de trabalho ou, no caso de sucessão, deverá ser maior ou igual à data da transferência do empregado.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1089','Um evento foi enviado ao mesmo tempo em mais de um lote ou dois ou mais eventos foram gerados e enviados com a mesma chave de acesso, verifique a chave de acesso e reenvie o evento. Ação sugerida para evitar o erro: Envie os eventos com chave de acesso diferentes e no mesmo lote, ou aguarde o processamento de um destes para o envio do outro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1090','Validação cadastral no NIS não realizada. Pendente de validação futura.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1091','Dois eventos que geram um novo e único registro de trabalhador foram enviados ao mesmo tempo em mais de um lote, reenvie o evento que gerou o erro. Ação sugerida para evitar o erro: Envie os eventos no mesmo lote ou aguarde o processamento de um destes para o envio do outro.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1092','Dois eventos que abrem uma folha de pagamento foram enviados ao mesmo tempo em mais de um lote, reenvie o evento que gerou o erro. Ação sugerida para evitar o erro: Envie os eventos no mesmo lote ou aguarde o processamento de um destes para o envio do outro. ',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1093','Dois eventos que geram um novo e único registro de empregador foram enviados ao mesmo tempo em mais de um lote.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1094','Este identificador já foi utilizado por evento já excluído ou retificado (recibo {0}).\nAção sugerida: Utilize outro ID e envie o evento novamente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1095','Este evento já foi recebido na base de dados do Ambiente Nacional. Evento: (recibo {0}).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1101','O número de processo judicial informado não foi localizado no cadastro do empregador no período.\nAção Sugerida: Verifique se o processo foi cadastrado, se é um processo judicial e se o campo indMatProc do evento S-1070 é igual a 7 ou corrija o campo de tipo de processo.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1105','O trabalhador deverá encontrar-se ativo no período ao qual se refere a remuneração, indicado em perRef.\nAção Sugerida: Verificar se o tabalhador relacionado encontra-se ativo no período.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1106','Processo FAP inexistente ou não pertence a esse CNPJ.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1108','O FAP desta empresa não foi calculado para este ano. Utilize o valor 1,000.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1111','CNO/CEI informado não é identificador de Obra. Ação Sugerida: Verifique o número informado. Se o mesmo se referir a Obra CNO, Obra CEI Pessoa Física ou Obra CEI Pessoa Jurídica, o 11o dígito deve ser igual a 5, 6 ou 7, respectivamente.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1159','Programa, plano ou documento inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 30 (Programas, Planos e Documentos).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1160','A retificação do evento de afastamento deve seguir a mesma parametrização do evento original (apenas início, ou apenas fim, ou início e fim).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1163','Código de treinamento/capacitação inválido.\nAção Sugerida: O valor informado no campo deverá existir na Tabela 29 (Treinamentos e capacitações).',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1168','Horas trabalhadas antes do acidente inválida.\nAção Sugerida: O valor do campo deve estar no intervalo entre [0000] e [9959].',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1169','Não deve ser preenchido quando o campo tpEP igual a 2.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1170','A inscrição informada deve ser diferente dos estabelecimentos cadastrados na Tabela S-1005 (Estabelecimentos e Obras) do empregador.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'1182','A data {0} deve ser compreendida ou anterior ao início de validade.',SYSDATE);
INSERT INTO ESO_INFCOMPLEMENTAR (NRINFCOMPLEMENTAR,NRORG,CDERRO,DSERRO,DTINCLUSAO) VALUES ((SELECT NVL(MAX(NRINFCOMPLEMENTAR),0)+1 FROM ESO_INFCOMPLEMENTAR),0,'9999','{0}',SYSDATE);